#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "a56.y"
/*******************************************************
 *
 *  a56 - a DSP56001 assembler
 *
 *  Written by Quinn C. Jensen
 *  July 1990
 *
 *******************************************************/

/*
 * Copyright (C) 1990-1994 Quinn C. Jensen
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.  The author makes no representations
 * about the suitability of this software for any purpose.  It is
 * provided "as is" without express or implied warranty.
 *
 */

/*
 *  a56.y - The YACC grammar for the assembler.
 *
 *  Note:  This module requires a "BIG" version of YACC.  I had to
 *  recompile YACC in the largest mode available.
 *
 *  Other notes:
 *
 *  MOVEC, MOVEM and MOVEP must be used explicitly--MOVE can't yet figure
 *  out which form to use.
 *
 */

#include "a56.h"

unsigned int w0, w1;			/* workspace for the actual generated code */
BOOL uses_w1;					/* says whether w1 is alive */
unsigned int pc;				/* current program counter */
int seg;						/* current segment P: X: Y: or L: */

int just_rep = 0;				/* keeps track of REP instruction */
int substatement = 0;			/* in a substatement */
BOOL long_symbolic_expr = FALSE; /* a parser flag */
char *new_include = NULL;		/* file to be included */

/* listing stuff */

char segs[] = "PXYL";
extern BOOL list_on_next;		/* listing to turn on or off */
BOOL list_on;					/* listing on at the moment */
extern char *cur_line;			/* points to line being lex'd */
char list_buf[1024 + 80];		/* listing buffer */
char list_buf2[1024 + 80];		/* listing buffer for two-line code */
BOOL uses_buf2 = FALSE;			/* list_buf2 is alive */
BOOL list_print_line = FALSE;	/* whether or not to print line in listing */
char *spaces(), *luntab();

struct n binary_op();
struct n unary_op();
struct n sym_ref();

#define R_R6				0x0001
#define R_R5				0x0002
#define R_R4				0x0004
#define R_DATA_ALU_ACCUM	0x0008
#define R_CTL_REG			0x0010
#define R_FUNKY_CTL_REG		0x0020
#define R_SDX				0x0040
#define R_SDY				0x0080
#define R_LSD				0x0100
#define R_AB				0x0200
#define R_XREG				0x0400
#define R_YREG				0x0800
/* registers to which short immediate move is an unsigned int */
#define R_UINT				0x1000
/* registers to which short immediate move is an signed frac */
#define R_SFRAC				0x2000
#line 83 "a56.y"
typedef union {
	int ival;			/* integer value */
	struct n n;			/* just like in struct sym */
	double dval;		/* floating point value */
	char *sval;			/* string */
	int cval;			/* character */
	char cond;			/* condition */
	struct regs {
		int r6, r5, r4, data_alu_accum, ctl_reg, funky_ctl_reg;
		int sdx, sdy, lsd, ab, xreg, yreg;
		int flags;
	} regs;
	struct ea {
		int mode;
		int ext;
		int pp;
	} ea;
} YYSTYPE;
#line 111 "y.tab.c"
#define CHEX 257
#define CDEC 258
#define FRAC 259
#define AREG 260
#define BREG 261
#define MREG 262
#define NREG 263
#define RREG 264
#define XREG 265
#define YREG 266
#define OP 267
#define OPA 268
#define OPP 269
#define OP_JCC 270
#define OP_JSCC 271
#define OP_TCC 272
#define SYM 273
#define STRING 274
#define CHAR 275
#define XMEM 276
#define YMEM 277
#define LMEM 278
#define PMEM 279
#define AAAA 280
#define A10 281
#define BBBB 282
#define B10 283
#define AABB 284
#define BBAA 285
#define XXXX 286
#define YYYY 287
#define SR 288
#define MR 289
#define CCR 290
#define OMR 291
#define SP 292
#define SSH 293
#define SSL 294
#define LA 295
#define LC 296
#define EOL 297
#define EOS 298
#define LEXBAD 299
#define OP_ABS 300
#define OP_ADC 301
#define OP_ADD 302
#define OP_ADDL 303
#define OP_ADDR 304
#define OP_ASL 305
#define OP_ASR 306
#define OP_CLR 307
#define OP_CMP 308
#define OP_CMPM 309
#define OP_DIV 310
#define OP_MAC 311
#define OP_MACR 312
#define OP_MPY 313
#define OP_MPYR 314
#define OP_NEG 315
#define OP_NORM 316
#define OP_RND 317
#define OP_SBC 318
#define OP_SUB 319
#define OP_SUBL 320
#define OP_SUBR 321
#define OP_TFR 322
#define OP_TST 323
#define OP_AND 324
#define OP_ANDI 325
#define OP_EOR 326
#define OP_LSL 327
#define OP_LSR 328
#define OP_NOT 329
#define OP_OR 330
#define OP_ORI 331
#define OP_ROL 332
#define OP_ROR 333
#define OP_BCLR 334
#define OP_BSET 335
#define OP_BCHG 336
#define OP_BTST 337
#define OP_DO 338
#define OP_ENDDO 339
#define OP_LUA 340
#define OP_MOVE 341
#define OP_MOVEC 342
#define OP_MOVEM 343
#define OP_MOVEP 344
#define OP_ILLEGAL 345
#define OP_INCLUDE 346
#define OP_JMP 347
#define OP_JCLR 348
#define OP_JSET 349
#define OP_JSR 350
#define OP_JSCLR 351
#define OP_JSSET 352
#define OP_NOP 353
#define OP_REP 354
#define OP_RESET 355
#define OP_RTI 356
#define OP_RTS 357
#define OP_STOP 358
#define OP_SWI 359
#define OP_WAIT 360
#define OP_EQU 361
#define OP_ORG 362
#define OP_DC 363
#define OP_DS 364
#define OP_DSM 365
#define OP_END 366
#define OP_PAGE 367
#define OP_PSECT 368
#define OP_ALIGN 369
#define OP_INT 370
#define SHL 371
#define SHR 372
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   38,   38,   38,   39,   39,   39,   39,   39,
   40,   41,   41,   41,   41,   41,   41,   41,   41,   41,
   41,   41,   41,   41,   44,   44,   45,   45,   34,   34,
   34,   34,   42,   42,   35,   35,   43,   46,   46,   46,
   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   28,   30,   30,   30,   29,   29,   29,   29,   20,
   20,   20,   20,   20,   20,   21,   21,   21,   21,   22,
   22,   22,   22,   23,   24,   24,   25,   26,   27,   27,
    9,    9,   47,   47,   47,   47,   53,   53,   53,   53,
   54,   54,   55,   55,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   58,   58,   58,   58,   58,   57,   57,
   57,   57,   57,   56,   56,   13,   13,   13,   13,   51,
   51,   51,   51,   59,   59,   15,   15,   15,   52,   52,
   52,   52,   52,   63,   63,   33,   31,   62,   62,   62,
   62,   62,   62,   60,   60,   60,   60,   60,   60,   37,
   37,   37,   61,   61,   12,   10,   10,   16,   16,   17,
   17,   11,   11,   14,   14,   14,   14,   18,   18,   18,
   18,   36,   36,   36,   36,   36,   36,   36,   36,   36,
   36,   36,   36,   36,   36,   36,   36,   19,   19,   19,
   19,   19,   19,   19,   32,   32,   32,   49,   49,   49,
   49,   49,   49,   49,   49,   64,   69,   65,   66,   66,
   66,   66,   67,   67,   67,   68,   68,   68,   71,   71,
   71,   71,   70,   70,   70,   70,    1,    1,    1,    5,
    5,    5,    6,    6,    7,    8,    2,    2,    2,    3,
    3,    3,    3,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    0,    1,    1,    2,    1,
    3,    3,    4,    2,    2,    6,    3,    6,    3,    3,
    3,    8,    2,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    0,    1,    0,    1,    1,    1,    2,
    2,    2,    2,    2,    2,    2,    1,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    4,    1,    1,    0,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    1,
    1,    3,    3,    1,    3,    3,    1,    1,    3,    3,
    1,    1,    1,    1,    1,    1,    4,    2,    4,    4,
    1,    1,    1,    1,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    3,    4,    4,    4,    1,    1,
    2,    2,    2,    6,    5,    1,    1,    1,    1,    2,
    2,    2,    2,    4,    3,    1,    1,    1,    2,    2,
    2,    4,    2,    1,    4,    3,    3,    4,    4,    3,
    4,    4,    3,    5,    4,    5,    5,    4,    4,    1,
    1,    1,    4,    4,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    5,    4,    5,    5,    4,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    3,    1,    4,    4,
    4,    4,    7,    6,    7,    7,    6,    7,    4,    4,
    4,    4,    8,    8,    8,    8,    1,    1,    1,    2,
    3,    3,    1,    2,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    4,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    2,    2,    3,    1,
};
short yydefred[] = {                                      1,
    0,    0,    0,    0,    0,   24,    0,    0,    0,    0,
    0,    2,    0,    7,    8,    0,    5,    0,   23,   30,
   31,   32,   29,    0,  257,  258,  259,    0,    0,  271,
  272,    0,    0,  273,    0,    0,  270,  288,    0,    0,
    0,    3,    4,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  114,    0,    0,    0,    0,    0,  112,    0,    0,
    0,    0,    0,    0,    0,  125,    0,   47,    0,    0,
    0,  131,    0,    0,    0,    0,    0,    0,  133,    0,
  128,  132,  129,  126,  130,  127,    0,    0,    9,   37,
   38,    0,  103,  104,  105,  106,    0,    0,    0,    0,
    0,    0,    0,    0,  285,  286,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   11,    0,    0,
    0,    0,    0,    0,  192,  191,  190,  193,  116,  194,
  115,  204,  205,  210,  209,  208,  202,  203,  206,  212,
  207,  213,  216,  217,  214,  215,  218,  219,  220,  221,
  222,  223,  224,  211,    0,    0,  163,  101,  102,   97,
   64,    0,    0,   70,    0,    0,    0,    0,    0,    0,
   46,    0,    0,   52,   94,   56,   98,   66,   62,   53,
    0,    0,    0,    0,   49,   50,  108,    0,   73,   74,
   43,    0,   44,   41,   42,   68,    0,   51,   71,   45,
   54,   58,   48,   57,    0,    0,   59,   61,   67,   63,
   55,   60,   69,   65,    0,  185,    0,  153,  152,  151,
  150,  186,  187,    0,    0,    0,  124,    0,    0,    0,
    0,    0,  161,    0,    0,  160,    0,    0,    0,    0,
  159,  118,    0,  122,  121,  117,  120,  119,  139,    0,
  140,  123,   27,    0,    0,   26,    0,    0,    0,    0,
  238,    0,   40,  228,  229,  230,  231,  232,  233,  234,
  235,    0,    0,    0,    0,    0,    0,    0,  287,    0,
    0,    0,    0,    0,    0,    0,  284,  283,  282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  189,  188,    0,    0,    0,    0,    0,  180,  181,
  182,    0,    0,    0,  142,  143,  141,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  274,
    0,    0,    0,    0,  166,   99,  100,   84,   85,   81,
   80,   82,   83,   93,   92,   88,   89,   87,   86,  167,
    0,    0,    0,  107,   95,   96,    0,    0,    0,  155,
  134,    0,    0,    0,  135,    0,  162,  170,    0,    0,
    0,  173,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,    0,    0,    0,    0,    0,    0,    0,    0,
  225,  226,  227,  109,  110,    0,    0,    0,  197,    0,
    0,    0,  165,   76,   78,   79,   77,   72,  157,  156,
  158,  154,  138,  137,  136,  171,  168,  172,  169,  184,
  183,    0,  268,  267,  175,  269,    0,    0,  179,  178,
  146,  147,  148,    0,  149,    0,  251,  249,    0,  240,
    0,  252,  250,  242,    0,    0,    0,    0,    0,  196,
  199,  198,  176,  177,  174,    0,  145,    0,    0,    0,
    0,    0,    0,    0,    0,   22,  144,  244,    0,    0,
    0,    0,    0,  247,    0,    0,  243,    0,    0,    0,
  245,  246,  248,  253,  254,  255,  256,
};
short yydgoto[] = {                                       1,
   37,  475,   38,  144,  236,  145,  146,  476,  180,  245,
  147,  237,  484,  148,  462,  354,  149,  150,  174,  191,
  205,  195,  196,  227,  181,  198,  184,  211,  333,  212,
  207,  444,  175,   24,   11,  176,  362,   12,   13,   14,
   15,   16,  109,  275,  276,  110,  111,  112,  283,  113,
  114,  115,  116,  117,  118,  264,  272,  247,  238,  261,
  256,  253,  177,  284,  285,  286,  287,  288,  289,  290,
  291,
};
short yysindex[] = {                                      0,
   88, -276, -291, -201,  -33,    0, -126, -192,  775, -126,
 -275,    0, -235,    0,    0, 1618,    0,  578,    0,    0,
    0,    0,    0,  775,    0,    0,    0,   64,  -33,    0,
    0,   84,  775,    0,  775,  775,    0,    0,    3, -112,
  775,    0,    0,  650,  650, 1945, -181, -130,  -70, -163,
 -163, -181, -181, -163,  -75,  -75, 1945,   94,   94,   94,
   94, -181, -136, -163, -130,  -70, -163, -163,  -75, -163,
  -87,    0,  -87, -181, -181, -163,  -87,    0, -181, -181,
  148,  148,  148,  148, 1023,    0,  163,    0, 1023, 1797,
  829,    0,  650,  148,  148,  650,  148,  148,    0, 1023,
    0,    0,    0,    0,    0,    0,  613,  775,    0,    0,
    0,  984,    0,    0,    0,    0,  148,  148,    3,  775,
  -30, -126,  775,  775,    0,    0,  -19,  775,  775,  775,
  775,  775,  775,  775,  775,  775,  775,    0,    3,  798,
  702,  775,  775,    3,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -50,  184,    0,    0,    0,    0,
    0,  186,  188,    0,  198,  210,  218,  235,  246,  254,
    0,  257,  258,    0,    0,    0,    0,    0,    0,    0,
  263,  273,  286,  288,    0,    0,    0,  291,    0,    0,
    0,  -78,    0,    0,    0,    0,  299,    0,    0,    0,
    0,    0,    0,    0,  310,  315,    0,    0,    0,    0,
    0,    0,    0,    0,  698,    0,  318,    0,    0,    0,
    0,    0,    0,  326,  650,  329,    0,  -38,  339,  347,
  650,  350,    0,  650,  352,    0,  706,  356,  289,  359,
    0,    0,  361,    0,    0,    0,    0,    0,    0,  650,
    0,    0,    0,    3,  364,    0,    3,  650,  372,  650,
    0,  373,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  374,  376,    3,  -33,  377,   40,   69,    0,  182,
  182,  128,  139,  194,   93,   93,    0,    0,    0,  737,
  131,    3,    3,  380, 1945, -181, -181, -181, -181,  -44,
  145, -181, -181,  146,  147, -181, -181,  151,  156, 1945,
  393,  398,  400, -181, -181, -181,  775,  775,    3, 1760,
  771,  401,  403,  405,  771,  410, 1945, 1945,  408,  409,
 1760,    0,    0,  415,  181,  417,  -79,  775,    0,    0,
    0,  418,  -79, 1760,    0,    0,    0,  613,  419,  420,
 1945,  425,  427, 1470, -146, -146,  775, -126,  775,    0,
  431,  211,  149,  212,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -18,   -5, -181,    0,    0,    0,    3,    3,  173,    0,
    0,  771,  771,  771,    0,  149,    0,    0, 1945, 1945,
  650,    0, 1945,  650,  -79, -137,    3, 1723, -137,  173,
  433,    0, 1945, 1945, 1945, 1945, 1945,  650,  650, 1061,
    0,    0,    0,    0,    0,    3,  436,    3,    0,  434,
  219,  220,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -137,    0,    0,    0,    0,  706,  289,    0,    0,
    0,    0,    0,  440,    0,  771,    0,    0,  441,    0,
 1834,    0,    0,    0, 1871,  706,  442,  443, -126,    0,
    0,    0,    0,    0,    0,  771,    0,  222,  706,  445,
  706,  446,  447, 1945,  216,    0,    0,    0,  450, -206,
  452, 1908, 1945,    0,  706, 1945,    0,  706, 1945,  706,
    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
 1364,    0, 1522,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -22,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    2,    2,    2,
    2,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  462,    0,    0,    0,    0,    0,  463,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -20,    0,    0,    0,    0,    0,    0,  -16,    0,
   -4,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   14,    0,
    0,    0,    0,  294,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  897,  945,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -42,   49,    0,   51,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   60,    0,    0,    0,    0,    0,  437,
  509, 1111, 1157,  385,  242,  344,    0,    0,    0,    0,
    0, 1208,  -40,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -34,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1247,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -28,   -1,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   28,    0,    0,    0,
    0,    0,    0,    0,   71,    0,    0,    0,    0,   95,
    0,    0,    0,    0,    0,  101,    0,  109,    0,    0,
 1286, 1325,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  112,    0,    0,    0,  116,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   -7, -404,    0,   18,  -80, -141, 1379, -229,  -13,  -24,
  642,   -2,    0, -190,    0,   77,    7,  -81,    0,  448,
   33,  135,  153,   36,    4,   12,  451,  108,    0,    0,
    0,  136,    0,   29,    0,  -56,   35,    0,    0,    0,
    0,    0,    0,    0,  150,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  111,    0,    0,  168,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 2241
short yytable[] = {                                      28,
  208,   28,   40,  265,  244,  249,  137,  132,  250,  260,
  258,  135,  133,  295,  134,  261,  136,  137,  132,  269,
   17,  299,  135,  133,  480,  134,   39,  136,  246,  360,
  281,  279,  252,  255,  260,  119,  292,  293,  197,  137,
  132,  121,  262,  271,  135,  133,  120,  134,  197,  136,
  125,  151,  126,  127,  344,  282,  199,  123,  139,  527,
  197,   42,   43,  131,  251,  197,  259,  503,  361,   18,
  528,  266,   19,  216,  131,  270,  137,  132,  230,  367,
   29,  135,  133,  234,  134,  229,  136,  280,  206,   41,
  233,  263,  263,  130,  263,  263,  131,  379,  178,  262,
  179,  223,  266,  342,  130,  137,  132,  122,  228,  380,
  135,  133,  232,  134,  296,  136,  192,  359,  193,   25,
   26,   27,   10,  124,  274,  277,  130,  217,  365,  137,
   25,   26,   27,  131,  135,  473,  209,  294,  210,  136,
  297,  298,  441,  442,  443,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  182,  183,  125,  127,  312,
  313,  138,  131,  130,  137,  132,  213,  214,  215,  135,
  133,  383,  134,  382,  136,  137,  132,  225,  226,  460,
  135,  133,  235,  134,  194,  136,  331,  332,  200,  201,
  202,  451,  130,  452,  185,  186,  242,  243,  218,  411,
  483,  221,  248,  415,  203,  265,  204,  267,  268,  187,
  231,  188,  141,  314,   34,  189,  190,  140,  137,  132,
  222,  131,  224,  135,  133,  346,  134,  315,  136,  316,
  137,  317,  143,  358,  142,  135,  133,  390,  134,  485,
  136,  318,   20,   21,   22,   23,  454,  455,  360,  239,
  240,  241,  339,  319,   28,   28,  265,  265,  385,  456,
  457,  320,  260,  260,   15,   15,   75,   75,  261,  261,
  463,  464,  465,  400,   14,   14,   39,   39,  321,  281,
   12,   12,  281,  410,  281,  281,  281,  361,  481,  322,
  417,  418,   17,   17,  422,  262,  262,  323,   35,  281,
  324,  325,  386,  387,  388,  389,  326,  431,  392,  393,
   21,   21,  396,  397,  435,  409,  327,  440,  164,  164,
  404,  405,  406,  377,  266,  266,  421,  127,  141,  328,
   34,  329,  426,  140,  330,  281,  359,  263,  429,  430,
  128,  129,  334,    2,  507,   19,   19,   20,   20,  439,
  142,  128,  129,  335,  407,  408,   13,   13,  336,  497,
    3,  340,  466,  467,  517,  281,  470,  236,  236,  341,
  447,  479,  345,  128,  129,  427,  487,  488,  489,  490,
  491,  280,  347,  498,  280,  274,  280,  280,  280,  458,
  348,  237,  237,  351,  446,  355,  448,   18,   18,  357,
  472,  280,  363,  478,  364,   16,   16,  368,  239,  239,
  128,  129,  241,  241,   35,  371,  374,  375,  474,  376,
  378,  474,  277,  384,  391,  277,  395,  394,  277,   25,
   26,   27,  398,    4,  510,  399,  401,  280,  512,  128,
  129,  402,  277,  403,  412,   30,  413,   31,  414,    5,
  416,  419,  420,    6,    7,    8,    9,  524,  423,  424,
  425,  428,  433,  434,  474,  531,  532,  280,  436,  534,
  437,  449,  536,  450,  500,  453,  486,  279,  277,  499,
  279,  501,  502,  506,  508,  514,  515,  518,  520,  522,
  523,  516,  525,  526,  279,  529,  113,  111,  128,  129,
  471,  281,  281,  281,  281,  281,  281,  281,  277,  128,
  129,  445,  505,  220,    0,  219,    0,  432,  281,    0,
    0,  281,  281,  281,  281,  281,  281,  281,  281,  281,
  279,    0,  281,  281,  281,  281,  281,  281,  281,  281,
    0,    0,   32,  358,    0,   25,   26,   27,    0,  278,
    0,    0,  278,  263,  263,  263,  263,  263,  263,  263,
  279,   30,    0,   31,    0,    0,  278,    0,    0,    0,
  263,    0,    0,  263,  263,  263,  263,  263,  263,  263,
  263,  263,    0,    0,  263,  263,  263,  263,  263,  263,
  263,  263,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  278,  280,  280,  280,  280,  280,  280,  280,
    0,    0,  281,  281,    0,    0,    0,   36,    0,   34,
  280,    0,   33,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  278,    0,  280,  280,  280,  280,  280,  280,
  280,  280,    0,    0,  277,  277,  277,  277,  277,  277,
  277,    0,   36,    0,   34,    0,    0,   33,   32,  358,
    0,  277,    0,    0,  277,  277,  277,  277,  277,  277,
  277,  277,  277,    0,    0,  277,  277,  277,  277,  277,
  277,  277,  277,    0,    0,    0,    0,    0,    0,  141,
    0,   34,    0,    0,  140,    0,  279,  279,  279,  279,
  279,  279,  279,   35,    0,    0,    0,    0,    0,  143,
    0,  142,    0,  279,  280,  280,  279,  279,  279,  279,
  279,  279,  279,  279,  279,    0,    0,  279,  279,  279,
  279,  279,  279,  279,  279,    0,    0,   36,   35,   34,
    0,   36,   33,   34,    0,  141,   33,   34,    0,    0,
  140,    0,    0,    0,    0,  277,  277,  338,    0,  337,
    0,    0,    0,    0,    0,    0,    0,  142,  278,  278,
  278,  278,  278,  278,  278,   35,   36,    0,   34,    0,
    0,   33,    0,    0,    0,  278,    0,    0,  278,  278,
  278,  278,  278,  278,  278,  278,  278,    0,    0,  278,
  278,  278,  278,  278,  278,  278,  278,  279,  279,    0,
   36,    0,   34,    0,   36,   33,   34,    0,    0,   33,
    0,    0,    0,   35,    0,    0,    0,   35,    0,    0,
    0,   35,  142,    0,   25,   26,   27,  310,    0,   34,
    0,    0,   33,    0,    0,    0,    0,    0,    0,    0,
   30,    0,   31,   20,   21,   22,   23,    0,    0,    0,
    0,    0,   35,  235,    0,    0,    0,    0,    0,   25,
   26,   27,    0,    0,    0,    0,    0,    0,    0,  278,
  278,    0,    0,    0,    0,   30,  273,   31,    0,    0,
    0,    0,  350,    0,    0,  353,   35,    0,  356,    0,
   35,    0,    0,    0,    0,    0,   25,   26,   27,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  370,
    0,  373,   30,   35,   31,    0,    0,    0,    0,    0,
    0,   90,    0,    0,    0,    0,   90,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   32,    0,    0,
    0,    0,    0,    0,   25,   26,   27,    0,   25,   26,
   27,    0,   25,   26,   27,  311,    0,    0,    0,    0,
   30,    0,   31,    0,   30,    0,   31,    0,   30,   91,
   31,    0,   32,    0,   91,    0,    0,    0,    0,    0,
    0,    0,    0,   25,   26,   27,    0,    0,    0,    0,
  381,    0,    0,    0,    0,    0,    0,    0,    0,   30,
    0,   31,    0,    0,    0,    0,    0,    0,  235,   32,
    0,    0,    0,  248,    0,    0,    0,   25,   26,   27,
    0,   25,   26,   27,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   30,    0,   31,    0,   30,    0,   31,
  461,    0,    0,    0,   25,   26,   27,  235,    0,    0,
    0,    0,  469,    0,    0,  353,    0,   32,    0,    0,
   30,   32,   31,    0,    0,   32,    0,    0,    0,  493,
  495,    0,    0,    0,    0,    0,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  235,    0,    0,    0,    0,
    0,    0,    0,    0,  242,  243,   32,  257,  159,  160,
  161,  162,  163,  164,  165,  166,  167,    0,  504,  168,
  169,  170,  171,  172,  173,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  513,    0,    0,
   32,    0,    0,    0,   32,    0,    0,    0,    0,    0,
  519,  275,  521,    0,  275,    0,   90,   90,   90,   90,
   90,   90,   90,    0,    0,    0,  533,   32,  275,  535,
    0,  537,   90,   90,   90,    0,   90,   90,   90,   90,
   90,   90,   90,   90,   90,    0,    0,   90,   90,   90,
   90,   90,   90,   90,   90,    0,    0,  276,    0,    0,
  276,    0,    0,    0,   91,   91,   91,   91,   91,   91,
   91,    0,    0,    0,  276,    0,    0,    0,    0,    0,
   91,   91,   91,    0,   91,   91,   91,   91,   91,   91,
   91,   91,   91,    0,  275,   91,   91,   91,   91,   91,
   91,   91,   91,  152,  153,  154,  155,  156,  157,  158,
  276,  264,    0,    0,    0,    0,    0,    0,    0,  242,
  243,  278,    0,  159,  160,  161,  162,  163,  164,  165,
  166,  167,    0,    0,  168,  169,  170,  171,  172,  173,
  276,    0,  152,  153,  154,  155,  156,  157,  158,    0,
  195,    0,    0,    0,    0,    0,    0,    0,  242,  243,
    0,    0,  159,  160,  161,  162,  163,  164,  165,  166,
  167,    0,    0,  168,  169,  170,  171,  172,  173,    0,
  152,  153,  154,  155,  156,  157,  158,    0,    0,  201,
    0,    0,    0,    0,    0,    0,    0,  496,    0,    0,
  159,  160,  161,  162,  163,  164,  165,  166,  167,    0,
    0,  168,  169,  170,  171,  172,  173,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  200,    0,
  275,  275,  275,  275,  275,  275,  275,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  275,    0,    0,
  275,  275,  275,  275,  275,  275,  275,  275,  275,    0,
    0,  275,  275,  275,  275,  275,  275,  275,  275,    0,
    0,    0,    0,    0,    0,    0,  276,  276,  276,  276,
  276,  276,  276,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  276,    0,    0,  276,  276,  276,  276,
  276,  276,  276,  276,  276,    0,    0,  276,  276,  276,
  276,  276,  276,  276,  276,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  264,  264,  264,
  264,  264,  264,  264,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  264,    0,    0,  264,  264,  264,
  264,  264,  264,  264,  264,  264,    0,    0,  264,  264,
  264,  264,  264,  264,  264,  264,  195,  195,  195,  195,
  195,  195,  195,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  195,    0,    0,  195,  195,  195,  195,
  195,  195,  195,  195,  195,    0,    0,  195,  195,  195,
  195,  195,  195,  195,  195,  201,  201,  201,    0,  201,
  201,  201,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  201,    0,    0,  201,  201,  201,  201,  201,
  201,  201,  201,  201,    0,    0,  201,  201,  201,  201,
  201,  201,  201,  201,  200,  200,  200,    0,  200,  200,
  200,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  200,    0,    0,  200,  200,  200,  200,  200,  200,
  200,  200,  200,    0,    0,  200,  200,  200,  200,  200,
  200,  200,  200,  343,    0,    0,    0,    0,    0,  349,
    0,    0,  352,   34,   34,   34,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  366,    0,
    0,    0,    0,    0,    0,    0,  369,    0,  372,    0,
    6,    6,    0,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   34,   34,   34,   34,    0,
   34,   34,   34,   34,   34,   34,   34,   34,   34,   34,
   34,   34,   34,   34,    0,    0,   34,   34,   36,  152,
  153,  154,  155,  156,  157,  158,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  242,  243,  438,    0,  159,
  160,  161,  162,  163,  164,  165,  166,  167,    0,    0,
  168,  169,  170,  171,  172,  173,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  459,    0,    0,
    0,   33,   33,   33,    0,    0,    0,    0,    0,  468,
    0,    0,  352,    0,    0,    0,    0,    0,  482,    0,
    0,    0,    0,    0,    0,    0,  492,  494,   10,   10,
    0,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,    0,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,    0,    0,   33,   33,   35,   44,   45,   46,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   47,   48,   49,
   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
   90,   91,   92,    0,   93,   94,   95,   96,   97,   98,
   99,  100,  101,  102,  103,  104,  105,  106,    0,    0,
  107,  108,  152,  153,  154,  155,  156,  157,  158,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  242,  243,
    0,  477,  159,  160,  161,  162,  163,  164,  165,  166,
  167,    0,    0,  168,  169,  170,  171,  172,  173,  152,
  153,  154,  155,  156,  157,  158,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  242,  243,    0,    0,  159,
  160,  161,  162,  163,  164,  165,  166,  167,    0,    0,
  168,  169,  170,  171,  172,  173,  152,  153,  154,  155,
  156,  157,  158,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  254,  159,  160,  161,  162,
  163,  164,  165,  166,  167,    0,    0,  168,  169,  170,
  171,  172,  173,  152,  153,  154,  155,  156,  157,  158,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  509,    0,    0,  159,  160,  161,  162,  163,  164,  165,
  166,  167,    0,    0,  168,  169,  170,  171,  172,  173,
  152,  153,  154,  155,  156,  157,  158,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  511,    0,    0,
  159,  160,  161,  162,  163,  164,  165,  166,  167,    0,
    0,  168,  169,  170,  171,  172,  173,  152,  153,  154,
  155,  156,  157,  158,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  530,    0,    0,  159,  160,  161,
  162,  163,  164,  165,  166,  167,    0,    0,  168,  169,
  170,  171,  172,  173,  152,  153,  154,  155,  156,  157,
  158,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  159,  160,  161,  162,  163,  164,
  165,  166,  167,    0,    0,  168,  169,  170,  171,  172,
  173,
};
short yycheck[] = {                                       7,
   57,   44,   10,   44,   85,   87,   37,   38,   89,   44,
   91,   42,   43,   44,   45,   44,   47,   37,   38,  100,
  297,   41,   42,   43,  429,   45,    9,   47,   85,  259,
  112,  112,   89,   90,   91,   18,  117,  118,   52,   37,
   38,   24,   44,  100,   42,   43,   18,   45,   62,   47,
   33,   45,   35,   36,  245,  112,   53,   29,   41,  266,
   74,  297,  298,   94,   89,   79,   91,  472,  259,  361,
  277,   44,  274,   62,   94,  100,   37,   38,   75,  270,
  273,   42,   43,   80,   45,   74,   47,  112,   56,  365,
   79,   94,   95,  124,   97,   98,   94,   58,  280,   93,
  282,   69,   96,  245,  124,   37,   38,   44,   73,   41,
   42,   43,   77,   45,  122,   47,  280,  259,  282,  257,
  258,  259,   35,   40,  107,  108,  124,  264,  270,   37,
  257,  258,  259,   94,   42,  273,   43,  120,   45,   47,
  123,  124,  289,  290,  291,  128,  129,  130,  131,  132,
  133,  134,  135,  136,  137,  286,  287,  140,  141,  142,
  143,  274,   94,  124,   37,   38,   59,   60,   61,   42,
   43,   41,   45,   43,   47,   37,   38,  265,  266,  409,
   42,   43,   35,   45,   50,   47,  265,  266,   54,  265,
  266,   43,  124,   45,  265,  266,  276,  277,   64,  341,
  430,   67,   40,  345,  280,   95,  282,   97,   98,  280,
   76,  282,   40,  264,   42,  286,  287,   45,   37,   38,
   68,   94,   70,   42,   43,  264,   45,   44,   47,   44,
   37,   44,   60,  371,   62,   42,   43,  282,   45,  430,
   47,   44,  276,  277,  278,  279,  265,  266,  478,   82,
   83,   84,  235,   44,  297,  298,  297,  298,  315,  265,
  266,   44,  297,  298,  297,  298,  265,  266,  297,  298,
  412,  413,  414,  330,  297,  298,  297,  298,   44,   38,
  297,  298,   41,  340,   43,   44,   45,  478,  430,   44,
  347,  348,  297,  298,  351,  297,  298,   44,  126,   58,
   44,   44,  316,  317,  318,  319,   44,  364,  322,  323,
  297,  298,  326,  327,  371,  340,   44,  374,  297,  298,
  334,  335,  336,  295,  297,  298,  351,  310,   40,   44,
   42,   44,  357,   45,   44,   94,  478,   44,  363,  364,
  371,  372,   44,  256,  486,  297,  298,  297,  298,  374,
   62,  371,  372,   44,  337,  338,  297,  298,   44,  440,
  273,   44,  419,  420,  506,  124,  423,  297,  298,   44,
  378,  428,   44,  371,  372,  358,  433,  434,  435,  436,
  437,   38,   44,  440,   41,  368,   43,   44,   45,  403,
   44,  297,  298,   44,  377,   44,  379,  297,  298,   44,
  425,   58,   44,  428,   44,  297,  298,   44,  297,  298,
  371,  372,  297,  298,  126,   44,   44,   44,  426,   44,
   44,  429,   38,   44,  280,   41,  280,  282,   44,  257,
  258,  259,  282,  346,  491,  280,   44,   94,  495,  371,
  372,   44,   58,   44,   44,  273,   44,  275,   44,  362,
   41,   44,   44,  366,  367,  368,  369,  514,   44,  279,
   44,   44,   44,   44,  472,  522,  523,  124,   44,  526,
   44,   41,  529,  263,   41,  264,   44,   41,   94,   44,
   44,  263,  263,   44,   44,   44,   44,  266,   44,   44,
   44,  499,  277,   44,   58,   44,   35,   35,  371,  372,
  424,  260,  261,  262,  263,  264,  265,  266,  124,  371,
  372,  376,  478,   66,   -1,   65,   -1,  368,  277,   -1,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
   94,   -1,  291,  292,  293,  294,  295,  296,  297,  298,
   -1,   -1,  370,  371,   -1,  257,  258,  259,   -1,   41,
   -1,   -1,   44,  260,  261,  262,  263,  264,  265,  266,
  124,  273,   -1,  275,   -1,   -1,   58,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   -1,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,  260,  261,  262,  263,  264,  265,  266,
   -1,   -1,  371,  372,   -1,   -1,   -1,   40,   -1,   42,
  277,   -1,   45,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  124,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,   -1,   -1,  260,  261,  262,  263,  264,  265,
  266,   -1,   40,   -1,   42,   -1,   -1,   45,  370,  371,
   -1,  277,   -1,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   42,   -1,   -1,   45,   -1,  260,  261,  262,  263,
  264,  265,  266,  126,   -1,   -1,   -1,   -1,   -1,   60,
   -1,   62,   -1,  277,  371,  372,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,  291,  292,  293,
  294,  295,  296,  297,  298,   -1,   -1,   40,  126,   42,
   -1,   40,   45,   42,   -1,   40,   45,   42,   -1,   -1,
   45,   -1,   -1,   -1,   -1,  371,  372,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   62,  260,  261,
  262,  263,  264,  265,  266,  126,   40,   -1,   42,   -1,
   -1,   45,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,   -1,   -1,  291,
  292,  293,  294,  295,  296,  297,  298,  371,  372,   -1,
   40,   -1,   42,   -1,   40,   45,   42,   -1,   -1,   45,
   -1,   -1,   -1,  126,   -1,   -1,   -1,  126,   -1,   -1,
   -1,  126,   62,   -1,  257,  258,  259,   40,   -1,   42,
   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  273,   -1,  275,  276,  277,  278,  279,   -1,   -1,   -1,
   -1,   -1,  126,   35,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,
  372,   -1,   -1,   -1,   -1,  273,  274,  275,   -1,   -1,
   -1,   -1,  251,   -1,   -1,  254,  126,   -1,  257,   -1,
  126,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  278,
   -1,  280,  273,  126,  275,   -1,   -1,   -1,   -1,   -1,
   -1,   35,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,   -1,  257,  258,
  259,   -1,  257,  258,  259,  264,   -1,   -1,   -1,   -1,
  273,   -1,  275,   -1,  273,   -1,  275,   -1,  273,   35,
  275,   -1,  370,   -1,   40,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,   -1,   -1,   -1,   -1,
  264,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  273,
   -1,  275,   -1,   -1,   -1,   -1,   -1,   -1,   35,  370,
   -1,   -1,   -1,   40,   -1,   -1,   -1,  257,  258,  259,
   -1,  257,  258,  259,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  273,   -1,  275,   -1,  273,   -1,  275,
  409,   -1,   -1,   -1,  257,  258,  259,   35,   -1,   -1,
   -1,   -1,  421,   -1,   -1,  424,   -1,  370,   -1,   -1,
  273,  370,  275,   -1,   -1,  370,   -1,   -1,   -1,  438,
  439,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,
  262,  263,  264,  265,  266,   35,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  276,  277,  370,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,   -1,  477,  291,
  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  496,   -1,   -1,
  370,   -1,   -1,   -1,  370,   -1,   -1,   -1,   -1,   -1,
  509,   41,  511,   -1,   44,   -1,  260,  261,  262,  263,
  264,  265,  266,   -1,   -1,   -1,  525,  370,   58,  528,
   -1,  530,  276,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,  291,  292,  293,
  294,  295,  296,  297,  298,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,  260,  261,  262,  263,  264,  265,
  266,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   -1,
  276,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,  124,  291,  292,  293,  294,  295,
  296,  297,  298,  260,  261,  262,  263,  264,  265,  266,
   94,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   -1,   -1,  291,  292,  293,  294,  295,  296,
  124,   -1,  260,  261,  262,  263,  264,  265,  266,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   -1,   -1,  291,  292,  293,  294,  295,  296,   -1,
  260,  261,  262,  263,  264,  265,  266,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   -1,
   -1,  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   44,   -1,
  260,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   -1,
   -1,  291,  292,  293,  294,  295,  296,  297,  298,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,  262,  263,
  264,  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,  291,  292,  293,
  294,  295,  296,  297,  298,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,  262,
  263,  264,  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,  291,  292,
  293,  294,  295,  296,  297,  298,  260,  261,  262,  263,
  264,  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,  291,  292,  293,
  294,  295,  296,  297,  298,  260,  261,  262,   -1,  264,
  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,   -1,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  260,  261,  262,   -1,  264,  265,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  245,   -1,   -1,   -1,   -1,   -1,  251,
   -1,   -1,  254,  270,  271,  272,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  278,   -1,  280,   -1,
  297,  298,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,   -1,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,   -1,   -1,  363,  364,  365,  260,
  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,   -1,   -1,
  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  409,   -1,   -1,
   -1,  270,  271,  272,   -1,   -1,   -1,   -1,   -1,  421,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  438,  439,  297,  298,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,   -1,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,   -1,   -1,  363,  364,  365,  270,  271,  272,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,   -1,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,   -1,   -1,
  363,  364,  260,  261,  262,  263,  264,  265,  266,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,   -1,   -1,  291,  292,  293,  294,  295,  296,  260,
  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,   -1,   -1,
  291,  292,  293,  294,  295,  296,  260,  261,  262,  263,
  264,  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,   -1,   -1,  291,  292,  293,
  294,  295,  296,  260,  261,  262,  263,  264,  265,  266,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,   -1,   -1,  291,  292,  293,  294,  295,  296,
  260,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,   -1,
   -1,  291,  292,  293,  294,  295,  296,  260,  261,  262,
  263,  264,  265,  266,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,   -1,   -1,  291,  292,
  293,  294,  295,  296,  260,  261,  262,  263,  264,  265,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,   -1,   -1,  291,  292,  293,  294,  295,
  296,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 372
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'#'",0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,0,
0,0,0,0,"':'",0,"'<'",0,"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'|'",0,"'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CHEX","CDEC","FRAC","AREG","BREG","MREG",
"NREG","RREG","XREG","YREG","OP","OPA","OPP","OP_JCC","OP_JSCC","OP_TCC","SYM",
"STRING","CHAR","XMEM","YMEM","LMEM","PMEM","AAAA","A10","BBBB","B10","AABB",
"BBAA","XXXX","YYYY","SR","MR","CCR","OMR","SP","SSH","SSL","LA","LC","EOL",
"EOS","LEXBAD","OP_ABS","OP_ADC","OP_ADD","OP_ADDL","OP_ADDR","OP_ASL","OP_ASR",
"OP_CLR","OP_CMP","OP_CMPM","OP_DIV","OP_MAC","OP_MACR","OP_MPY","OP_MPYR",
"OP_NEG","OP_NORM","OP_RND","OP_SBC","OP_SUB","OP_SUBL","OP_SUBR","OP_TFR",
"OP_TST","OP_AND","OP_ANDI","OP_EOR","OP_LSL","OP_LSR","OP_NOT","OP_OR",
"OP_ORI","OP_ROL","OP_ROR","OP_BCLR","OP_BSET","OP_BCHG","OP_BTST","OP_DO",
"OP_ENDDO","OP_LUA","OP_MOVE","OP_MOVEC","OP_MOVEM","OP_MOVEP","OP_ILLEGAL",
"OP_INCLUDE","OP_JMP","OP_JCLR","OP_JSET","OP_JSR","OP_JSCLR","OP_JSSET",
"OP_NOP","OP_REP","OP_RESET","OP_RTI","OP_RTS","OP_STOP","OP_SWI","OP_WAIT",
"OP_EQU","OP_ORG","OP_DC","OP_DS","OP_DSM","OP_END","OP_PAGE","OP_PSECT",
"OP_ALIGN","OP_INT","SHL","SHR",
};
char *yyrule[] = {
"$accept : input",
"input :",
"input : input statement",
"statement : good_stuff EOL",
"statement : good_stuff EOS",
"statement : error EOL",
"good_stuff :",
"good_stuff : cpp_droppings",
"good_stuff : assembler_ops",
"good_stuff : label_field operation_field",
"good_stuff : SYM",
"cpp_droppings : '#' num STRING",
"assembler_ops : SYM OP_EQU expr",
"assembler_ops : SYM OP_EQU space expr",
"assembler_ops : OP_ALIGN expr",
"assembler_ops : OP_PSECT SYM",
"assembler_ops : OP_PSECT SYM space expr ':' expr",
"assembler_ops : OP_ORG space expr",
"assembler_ops : OP_ORG space expr ',' space expr",
"assembler_ops : label_field OP_DC dc_list",
"assembler_ops : label_field OP_DS expr",
"assembler_ops : opt_label OP_DSM expr",
"assembler_ops : OP_PAGE num ',' num ',' num ',' num",
"assembler_ops : OP_INCLUDE STRING",
"assembler_ops : OP_END",
"dc_list : dc_list ',' dc_stuff",
"dc_list : dc_stuff",
"dc_stuff : STRING",
"dc_stuff : expr",
"space : PMEM",
"space : XMEM",
"space : YMEM",
"space : LMEM",
"label_field : SYM",
"label_field :",
"opt_label : SYM",
"opt_label :",
"operation_field : operation",
"operation : no_parallel",
"operation : parallel_ok",
"operation : parallel_ok parallel_move",
"parallel_ok : OP_MPY mpy_arg",
"parallel_ok : OP_MPYR mpy_arg",
"parallel_ok : OP_MAC mpy_arg",
"parallel_ok : OP_MACR mpy_arg",
"parallel_ok : OP_SUB op8_1",
"parallel_ok : OP_ADD op8_1",
"parallel_ok : OP_MOVE",
"parallel_ok : OP_TFR op8_2",
"parallel_ok : OP_CMP op8_2",
"parallel_ok : OP_CMPM op8_2",
"parallel_ok : OP_RND op8_3",
"parallel_ok : OP_ADDL op8_3",
"parallel_ok : OP_CLR op8_3",
"parallel_ok : OP_SUBL op8_3",
"parallel_ok : OP_NOT op8_3",
"parallel_ok : OP_ADDR op8_4",
"parallel_ok : OP_TST op8_4",
"parallel_ok : OP_SUBR op8_4",
"parallel_ok : OP_AND op8_5",
"parallel_ok : OP_OR op8_5",
"parallel_ok : OP_EOR op8_5",
"parallel_ok : OP_ASR op8_6",
"parallel_ok : OP_LSR op8_6",
"parallel_ok : OP_ABS op8_6",
"parallel_ok : OP_ROR op8_6",
"parallel_ok : OP_ASL op8_7",
"parallel_ok : OP_LSL op8_7",
"parallel_ok : OP_NEG op8_7",
"parallel_ok : OP_ROL op8_7",
"parallel_ok : OP_ADC op8_8",
"parallel_ok : OP_SBC op8_8",
"mpy_arg : plus_minus mpy_srcs ',' a_b",
"plus_minus : '+'",
"plus_minus : '-'",
"plus_minus :",
"mpy_srcs : XREG ',' XREG",
"mpy_srcs : YREG ',' YREG",
"mpy_srcs : XREG ',' YREG",
"mpy_srcs : YREG ',' XREG",
"op8_1 : BBBB ',' AAAA",
"op8_1 : AAAA ',' BBBB",
"op8_1 : XXXX ',' a_b",
"op8_1 : YYYY ',' a_b",
"op8_1 : XREG ',' a_b",
"op8_1 : YREG ',' a_b",
"op8_2 : BBBB ',' AAAA",
"op8_2 : AAAA ',' BBBB",
"op8_2 : XREG ',' a_b",
"op8_2 : YREG ',' a_b",
"op8_3 : AAAA",
"op8_3 : BBBB",
"op8_3 : BBBB ',' AAAA",
"op8_3 : AAAA ',' BBBB",
"op8_4 : op8_3",
"op8_5 : XREG ',' a_b",
"op8_5 : YREG ',' a_b",
"op8_6 : a_b",
"op8_7 : a_b",
"op8_8 : XXXX ',' a_b",
"op8_8 : YYYY ',' a_b",
"a_b : AAAA",
"a_b : BBBB",
"no_parallel : control_inst",
"no_parallel : bit_inst",
"no_parallel : move_inst",
"no_parallel : arith_inst",
"arith_inst : OP_NORM RREG ',' a_b",
"arith_inst : OP_DIV sd3",
"arith_inst : or_op ix ',' funky_ctl_reg",
"arith_inst : and_op ix ',' funky_ctl_reg",
"or_op : OP_OR",
"or_op : OP_ORI",
"and_op : OP_AND",
"and_op : OP_ANDI",
"control_inst : OP_JSCC ea_a12",
"control_inst : OP_JCC ea_a12",
"control_inst : OP_JSR ea_a12",
"control_inst : OP_JMP ea_a12",
"control_inst : OP_JSSET control_args",
"control_inst : OP_JSCLR control_args",
"control_inst : OP_JSET control_args",
"control_inst : OP_JCLR control_args",
"control_inst : OP_REP rep_args",
"control_inst : OP_DO do_args",
"control_inst : OP_ENDDO",
"control_inst : OP_STOP",
"control_inst : OP_WAIT",
"control_inst : OP_RESET",
"control_inst : OP_RTS",
"control_inst : OP_SWI",
"control_inst : OP_ILLEGAL",
"control_inst : OP_RTI",
"control_inst : OP_NOP",
"do_args : ix ',' abs_addr",
"do_args : regs ',' abs_addr",
"do_args : x_or_y ea_no_ext ',' abs_addr",
"do_args : x_or_y abs_short_addr ',' abs_addr",
"do_args : x_or_y abs_addr ',' abs_addr",
"rep_args : ix",
"rep_args : regs",
"rep_args : x_or_y ea_no_ext",
"rep_args : x_or_y abs_addr",
"rep_args : x_or_y abs_short_addr",
"control_args : b5_10111_max ',' x_or_y p6_ean_a6 ',' abs_addr",
"control_args : b5_10111_max ',' regs ',' abs_addr",
"p6_ean_a6 : abs_addr",
"p6_ean_a6 : abs_short_addr",
"p6_ean_a6 : io_short_addr",
"p6_ean_a6 : ea_no_ext",
"bit_inst : OP_BTST bit_args",
"bit_inst : OP_BCHG bit_args",
"bit_inst : OP_BSET bit_args",
"bit_inst : OP_BCLR bit_args",
"bit_args : b5_10111_max ',' x_or_y p6_ea_a6",
"bit_args : b5_10111_max ',' regs",
"p6_ea_a6 : io_short_addr",
"p6_ea_a6 : abs_short_addr",
"p6_ea_a6 : ea",
"move_inst : OP_MOVEP movep_args",
"move_inst : OP_MOVEM movem_args",
"move_inst : OP_MOVEC movec_args",
"move_inst : OP_LUA ea_short ',' regs",
"move_inst : OP_TCC tcc_args",
"tcc_args : tcc_sd",
"tcc_args : tcc_sd RREG ',' RREG",
"tcc_sd : regs ',' regs",
"sd3 : regs ',' regs",
"movec_args : x_or_y ea ',' regs",
"movec_args : regs ',' x_or_y ea",
"movec_args : ix ',' regs",
"movec_args : x_or_y abs_short_addr ',' regs",
"movec_args : regs ',' x_or_y abs_short_addr",
"movec_args : regs ',' regs",
"movep_args : x_or_y movep_ea_pp ',' x_or_y movep_ea_pp",
"movep_args : ix ',' x_or_y num_or_sym",
"movep_args : PMEM ea ',' x_or_y num_or_sym",
"movep_args : x_or_y movep_ea_pp ',' PMEM ea",
"movep_args : regs ',' x_or_y num_or_sym",
"movep_args : x_or_y movep_ea_pp ',' regs",
"movep_ea_pp : abs_addr",
"movep_ea_pp : io_short_addr",
"movep_ea_pp : ea_no_ext",
"movem_args : regs ',' PMEM ea_a6",
"movem_args : PMEM ea_a6 ',' regs",
"b5_10111_max : ix",
"x_or_y : XMEM",
"x_or_y : YMEM",
"ea_a6 : ea",
"ea_a6 : abs_short_addr",
"ea_a12 : ea",
"ea_a12 : abs_short_addr",
"ea : abs_addr",
"ea : ea_no_ext",
"ea_no_ext : ea_short",
"ea_no_ext : '(' RREG ')'",
"ea_no_ext : '(' RREG '+' NREG ')'",
"ea_no_ext : '-' '(' RREG ')'",
"ea_short : '(' RREG ')' '-' NREG",
"ea_short : '(' RREG ')' '+' NREG",
"ea_short : '(' RREG ')' '-'",
"ea_short : '(' RREG ')' '+'",
"regs : XREG",
"regs : YREG",
"regs : AREG",
"regs : BREG",
"regs : AAAA",
"regs : BBBB",
"regs : RREG",
"regs : NREG",
"regs : MREG",
"regs : prog_ctl_reg",
"regs : A10",
"regs : B10",
"regs : XXXX",
"regs : YYYY",
"regs : AABB",
"regs : BBAA",
"prog_ctl_reg : SR",
"prog_ctl_reg : OMR",
"prog_ctl_reg : SP",
"prog_ctl_reg : SSH",
"prog_ctl_reg : SSL",
"prog_ctl_reg : LA",
"prog_ctl_reg : LC",
"funky_ctl_reg : MR",
"funky_ctl_reg : CCR",
"funky_ctl_reg : OMR",
"parallel_move : i_move",
"parallel_move : u_move",
"parallel_move : x_or_y_move",
"parallel_move : xr_move",
"parallel_move : ry_move",
"parallel_move : r_move",
"parallel_move : xy_move",
"parallel_move : l_move",
"i_move : ix ',' regs",
"r_move : regs ',' regs",
"u_move : ea_short",
"x_or_y_move : x_or_y ea ',' regs",
"x_or_y_move : x_or_y abs_short_addr ',' regs",
"x_or_y_move : regs ',' x_or_y ea",
"x_or_y_move : regs ',' x_or_y abs_short_addr",
"xr_move : x_or_y ea ',' regs regs ',' YREG",
"xr_move : ix ',' regs regs ',' YREG",
"xr_move : regs ',' x_or_y ea regs ',' regs",
"ry_move : regs ',' regs YMEM ea ',' regs",
"ry_move : regs ',' regs ix ',' regs",
"ry_move : regs ',' regs regs ',' YMEM ea",
"l_move : LMEM ea ',' regs",
"l_move : regs ',' LMEM ea",
"l_move : LMEM abs_short_addr ',' regs",
"l_move : regs ',' LMEM abs_short_addr",
"xy_move : x_or_y ea ',' regs YMEM ea ',' regs",
"xy_move : x_or_y ea ',' regs regs ',' YMEM ea",
"xy_move : regs ',' x_or_y ea YMEM ea ',' regs",
"xy_move : regs ',' x_or_y ea regs ',' YMEM ea",
"num : CHEX",
"num : CDEC",
"num : FRAC",
"ix : '#' expr",
"ix : '#' '>' expr",
"ix : '#' '<' expr",
"abs_addr : expr",
"abs_addr : '>' expr",
"abs_short_addr : '<' expr",
"io_short_addr : SHL expr",
"num_or_sym : num",
"num_or_sym : SYM",
"num_or_sym : io_short_addr",
"num_or_sym_expr : num",
"num_or_sym_expr : SYM",
"num_or_sym_expr : CHAR",
"num_or_sym_expr : '*'",
"expr : OP_INT '(' expr ')'",
"expr : expr '|' expr",
"expr : expr '^' expr",
"expr : expr '&' expr",
"expr : expr SHR expr",
"expr : expr SHL expr",
"expr : expr '-' expr",
"expr : expr '+' expr",
"expr : expr '%' expr",
"expr : expr '/' expr",
"expr : expr '*' expr",
"expr : '-' expr",
"expr : '~' expr",
"expr : '(' expr ')'",
"expr : num_or_sym_expr",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1649 "a56.y"

#include <stdio.h>

int yydebug;

struct n binary_op(a1, op, a2)
struct n a1, a2;
int op;
{
	struct n result;

	if(a1.type == UNDEF || a2.type == UNDEF) {
		result.type = UNDEF;
		return result;
	}

	/* promote to float automatically */

	if(a1.type != a2.type) {
		if(a1.type == INT) {
			a1.val.f = a1.val.i;		/* truncate */
			a1.type = FLT;
		} else {
			a2.val.f = a2.val.i;		/* truncate */
		}
	}
	result.type = a1.type;

	/* do the op */

	if(result.type == INT) {
		switch(op) {
			case '+':		result.val.i = a1.val.i + a2.val.i; break;
			case '-':		result.val.i = a1.val.i - a2.val.i; break;
			case '*':		result.val.i = a1.val.i * a2.val.i; break;
			case '/':		result.val.i = a1.val.i / a2.val.i; break;
			case '%':		result.val.i = a1.val.i % a2.val.i; break;
			case SHL:		result.val.i = a1.val.i << a2.val.i; break;
			case SHR:		result.val.i = a1.val.i >> a2.val.i; break;
			case '|':		result.val.i = a1.val.i | a2.val.i; break;
			case '&':		result.val.i = a1.val.i & a2.val.i; break;
			case '^':		result.val.i = a1.val.i ^ a2.val.i; break;
		}
	} else {
		switch(op) {
			case '+':		result.val.f = a1.val.f + a2.val.f; break;
			case '-':		result.val.f = a1.val.f - a2.val.f; break;
			case '*':		result.val.f = a1.val.f * a2.val.f; break;
			case '/':		result.val.f = a1.val.f / a2.val.f; break;
			case '%':		result.val.f = (int)a1.val.f % (int)a2.val.f; break;
			case SHL:		result.val.f = (int)a1.val.f << (int)a2.val.f; break;
			case SHR:		result.val.f = (int)a1.val.f >> (int)a2.val.f; break;
			case '|':		result.val.f = (int)a1.val.f | (int)a2.val.f; break;
			case '&':		result.val.f = (int)a1.val.f & (int)a2.val.f; break;
			case '^':		result.val.f = (int)a1.val.f ^ (int)a2.val.f; break;
		}
	}

	return result;
}

struct n unary_op(op, a1)
int op;
struct n a1;
{
	struct n result;

	if(a1.type == UNDEF) {
		result.type = UNDEF;
		return result;
	}

	result.type = a1.type;

	/* do the op */

	if(result.type == INT) {
		switch(op) {
			case '-':		result.val.i = -a1.val.i; break;
			case '~':		result.val.i = ~a1.val.i; break;
		}
	} else {
		switch(op) {
			case '-':		result.val.f = -a1.val.f; break;
			case '~':		result.val.f = ~(int)a1.val.f; break;
		}
	}

	return result;
}

n2int(n)
struct n n;
{
	if(n.type == UNDEF)
		return UNDEF;
	else if(n.type == INT)
		return n.val.i;
	else
		return n.val.f;
}

n2frac(n)
struct n n;
{
	double adval = n.val.f;
	/*
	if (n.val.f > 0.0f) 
	  adval = n.val.f;
	else
	  adval = -n.val.f;
	  */
	  
	if(n.type == UNDEF)
		return UNDEF;
	else if(n.type == INT)
		return n.val.i;
	else if(n.val.f == -1.0)
		return 0x800000;

	adval -= (double)(int)adval;
	adval *= (double)0x800000;
	adval += 0.5;

	if(n.val.f >= 0.0)
		return adval;
	else
		return -adval;
}

extern struct {int n; char *name;} tok_tab[];
extern int n_tok;

char *tok_print(tok)
int tok;
{
	int i;
	static char buf[32];

	if(tok < 256) {
		sprintf(buf, tok < ' ' ? "\\z%02X" : "%c", tok & 0xFF);
		return buf;
	} else {
		for(i = 0; i < n_tok; i++) {
			if(tok == tok_tab[i].n)
				return tok_tab[i].name;
		}
	}
	return "*bogus*";
}

yyerror(s, a0, a1, a2, a3)
char *s, *a0, *a1, *a2, *a3;
{
	extern int error;
	char buf[1024];

	error++;
	sprintf(buf, s, a0, a1, a2, a3);

	if(pass == 2) {
		fprintf(stderr, "%s: line %d: %s (tok=%s)\n", curfile, curline,
			buf, tok_print(yychar));
		fprintf(stderr, "%s\n", cur_line);
		printf("%s: line %d: %s (tok=%s)\n", curfile, curline,
			buf, tok_print(yychar));
	}
}

char *luntab(s)
char *s;
{
	static char buf[1024];
	int p;

	strcpy(buf, s);

	untab(buf);
	p = strlen(buf);

	if(buf[p - 1] == '\n')
		buf[p - 1] = '\0';

	return buf;
}
#line 1463 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 247 "a56.y"
{
			if(pass == 2 && list_on && list_print_line) {
				printf(ldebug ? "\n(%s|%s)\n" : "%s%s\n",
					list_buf, substatement == 0 ? luntab(cur_line) : "");
				if(uses_buf2)
					printf(ldebug ? "\n(%s|)\n" : "%s\n",
						list_buf2);
				list_buf[0] = list_buf2[0] = '\0';
			}
			curline++;
			uses_buf2 = FALSE;
			list_print_line = TRUE;
			list_on = list_on_next;
			substatement = 0;
			if(NOT check_psect(seg, pc) && pass == 2)
				yyerror("%04X: psect violation", pc);
			}
break;
case 4:
#line 265 "a56.y"
{
			if(pass == 2 && list_on && list_print_line) {
				printf(ldebug ? "\n(%s" : "%s", list_buf);
				if(substatement == 0)
					printf(ldebug ? "|%s)\n" : "%s\n", luntab(cur_line));
				else
					printf(ldebug ? ")\n" : "\n");
				if(uses_buf2)
					printf(ldebug ? "\n(%s|)\n" : "%s\n",
						list_buf2);
				list_buf[0] = list_buf2[0] = '\0';
			}
			substatement++;
			uses_buf2 = FALSE;
			list_print_line = TRUE;
			list_on = list_on_next;
			if(NOT check_psect(seg, pc) && pass == 2)
				yyerror("%04X: psect violation", pc);
			}
break;
case 5:
#line 285 "a56.y"
{curline++; substatement = 0;}
break;
case 6:
#line 290 "a56.y"
{sprintf(list_buf, "%s", spaces(0));}
break;
case 7:
#line 292 "a56.y"
{list_print_line = FALSE;}
break;
case 8:
#line 294 "a56.y"
{long_symbolic_expr = FALSE;}
break;
case 9:
#line 296 "a56.y"
{char *printcode();
			if(pass == 2) {
				gencode(seg, pc, w0);
				sprintf(list_buf, "%c:%04X %s ", segs[seg], pc, printcode(w0));
				pc++;
				if(uses_w1) {
					gencode(seg, pc, w1);
					sprintf(list_buf2, "%c:%04X %s", segs[seg], pc,
	       					printcode(w1 & 0xFFFFFF));
					uses_buf2++;
					pc++;
				}
			} else {
				pc++;
				if(uses_w1)
					pc++;
			}
			w0 = w1 = 0; uses_w1 = FALSE; 
			long_symbolic_expr = FALSE;}
break;
case 10:
#line 316 "a56.y"
{sym_def(yyvsp[0].sval,seg, INT, pc);
			free(yyvsp[0].sval);
			if(pass == 2 && list_on) {
				sprintf(list_buf, "%c:%04X%s", segs[seg], pc, spaces(14-8));
			long_symbolic_expr = FALSE;
			}}
break;
case 11:
#line 326 "a56.y"
{if(strlen(yyvsp[0].sval) > 0)
				curfile = yyvsp[0].sval;
			else
				curfile = "<stdin>";
			curline = yyvsp[-1].n.val.i - 1;}
break;
case 12:
#line 335 "a56.y"
{sym_def(yyvsp[-2].sval,seg, yyvsp[0].n.type, yyvsp[0].n.val.i, yyvsp[0].n.val.f);
			free(yyvsp[-2].sval);
			if(pass == 2 && list_on) {
				if(yyvsp[0].n.type == INT)
					sprintf(list_buf, "%06X%s",
						yyvsp[0].n.val.i & 0xFFFFFF,
						spaces(14-8));
				else
					sprintf(list_buf, "%10g%s", yyvsp[0].n.val.f,
						spaces(14-4));
			}}
break;
case 13:
#line 347 "a56.y"
{sym_def(yyvsp[-3].sval,yyvsp[-1].ival, yyvsp[0].n.type, yyvsp[0].n.val.i, yyvsp[0].n.val.f);
			free(yyvsp[-3].sval);
			if(pass == 2 && list_on) {
				if(yyvsp[0].n.type == INT)
					sprintf(list_buf, "%06X%s",
						yyvsp[0].n.val.i & 0xFFFFFF,
						spaces(14-8));
				else
					sprintf(list_buf, "%10g%s", yyvsp[0].n.val.f,
						spaces(14-4));
			}}
break;
case 14:
#line 359 "a56.y"
{int ival = n2int(yyvsp[0].n);
			if(yyvsp[0].n.type == UNDEF) {
				yyerror("illegal forward reference");
			} else if (ival <= 1) {
				yyerror("%d: illegal alignment", ival);
			} else {
				if(pc % ival != 0)
					pc += ival - pc % ival;
			}
			if(pass == 2 && list_on)
				sprintf(list_buf, "%c:%04X%s", segs[seg], pc, 
					spaces(14-8));
			}
break;
case 15:
#line 373 "a56.y"
{struct psect *pp = find_psect(yyvsp[0].sval);
			if(NOT pp) {
				if(pass == 2)
					yyerror("%s: undefined psect", yyvsp[0].sval);
			} else {
				seg = pp->seg;
				pc = pp->pc;
				set_psect(pp);
				if(pass == 2 && list_on)
					sprintf(list_buf, "%c:%04X%s", segs[seg], pc,
						spaces(14-8));
			}
			free(yyvsp[0].sval);}
break;
case 16:
#line 387 "a56.y"
{new_psect(yyvsp[-4].sval, yyvsp[-3].ival, n2int(yyvsp[-2].n), n2int(yyvsp[0].n));
			if(pass == 2 && list_on)
				sprintf(list_buf, "%c:%04X %04X%s", 
					segs[yyvsp[-3].ival], n2int(yyvsp[-2].n), n2int(yyvsp[0].n), spaces(14-8+4+1));
			}
break;
case 17:
#line 393 "a56.y"
{pc = n2int(yyvsp[0].n);
			seg = yyvsp[-1].ival;
			if(pass == 2 && list_on)
				sprintf(list_buf, "%c:%04X%s", segs[seg], pc, 
					spaces(14-8));
			}
break;
case 18:
#line 400 "a56.y"
{pc = n2int(yyvsp[-3].n);
			seg = yyvsp[-4].ival;
			if(pass == 2 && list_on)
				sprintf(list_buf, "%c:%04X%s", segs[seg], pc, 
					spaces(14-8));
			}
break;
case 20:
#line 408 "a56.y"
{pc += n2int(yyvsp[0].n);
			}
break;
case 21:
#line 411 "a56.y"
{int size = n2int(yyvsp[0].n);
			/* GGeiger fixed the wrong label bug */
			if(yyvsp[-2].sval)
			{   sym_def(yyvsp[-2].sval,seg, INT, pc);
 			    free(yyvsp[-2].sval);
			}
			if(size)
			{    int align = 1;
			     while(align < size)
				 align <<= 1;
			     pc += (align - (pc % align));
			}
			pc += size;
			}
break;
case 22:
#line 426 "a56.y"
{if(pass == 2 && list_on) {
				sprintf(list_buf, "%s", spaces(0));
			}}
break;
case 23:
#line 430 "a56.y"
{if(pass == 2 && list_on) {
				printf(ldebug ? "\n(%s|%s)\n" : "%s%s\n",
					spaces(0), luntab(cur_line));
				list_print_line = FALSE;
			}
			include(yyvsp[0].sval); /* free($2); */
			}
break;
case 24:
#line 438 "a56.y"
{if(pass == 2 && list_on) {
				sprintf(list_buf, "%s", spaces(0));
			}}
break;
case 27:
#line 450 "a56.y"
{int len = strlen(yyvsp[0].sval), i; char *cp; w0 = 0;
			if(len % 3 == 2)
				len++;	/* force empty word */
			for(i = 0, cp = yyvsp[0].sval; i < len; i++, cp++) {
				w0 |= (*cp & 0xFF) << (2 - (i % 3)) * 8;
				if(i % 3 == 2 || i == len - 1) {
					if(pass == 2) {
						if(list_on) sprintf(list_buf, "%c:%04X %06X%s",
							segs[seg], pc, w0, 
							spaces(14-6+5));
						gencode(seg, pc, w0);
					}
					pc++; w0 = 0;
				}
			}
			free(yyvsp[0].sval);}
break;
case 28:
#line 467 "a56.y"
{int frac = n2frac(yyvsp[0].n);
			if(pass == 2) {
				if(list_on) {
					sprintf(list_buf, "%c:%04X %06X%s", segs[seg], pc, 
						frac & 0xFFFFFF, spaces(14-6+5));
				}
				gencode(seg, pc, frac);
			}
			pc++;}
break;
case 29:
#line 478 "a56.y"
{yyval.ival = PROG;}
break;
case 30:
#line 480 "a56.y"
{yyval.ival = XDATA;}
break;
case 31:
#line 482 "a56.y"
{yyval.ival = YDATA;}
break;
case 32:
#line 484 "a56.y"
{yyval.ival = LDATA;}
break;
case 33:
#line 489 "a56.y"
{sym_def(yyvsp[0].sval,seg, INT, pc);
			free(yyvsp[0].sval);}
break;
case 35:
#line 495 "a56.y"
{yyval.sval = yyvsp[0].sval;}
break;
case 36:
#line 496 "a56.y"
{yyval.sval = NULL;}
break;
case 37:
#line 501 "a56.y"
{if(just_rep) 
				just_rep--;}
break;
case 39:
#line 508 "a56.y"
{w0 |= 0x200000;}
break;
case 41:
#line 517 "a56.y"
{w0 |= 0x80 | yyvsp[0].ival << 2;}
break;
case 42:
#line 519 "a56.y"
{w0 |= 0x81 | yyvsp[0].ival << 2;}
break;
case 43:
#line 521 "a56.y"
{w0 |= 0x82 | yyvsp[0].ival << 2;}
break;
case 44:
#line 523 "a56.y"
{w0 |= 0x83 | yyvsp[0].ival << 2;}
break;
case 45:
#line 526 "a56.y"
{w0 |= 0x04 | yyvsp[0].ival << 3;}
break;
case 46:
#line 528 "a56.y"
{w0 |= 0x00 | yyvsp[0].ival << 3;}
break;
case 47:
#line 530 "a56.y"
{w0 |= 0x00;}
break;
case 48:
#line 533 "a56.y"
{w0 |= 0x01 | yyvsp[0].ival << 3;}
break;
case 49:
#line 535 "a56.y"
{w0 |= 0x05 | yyvsp[0].ival << 3;}
break;
case 50:
#line 537 "a56.y"
{w0 |= 0x07 | yyvsp[0].ival << 3;}
break;
case 51:
#line 540 "a56.y"
{w0 |= 0x11 | yyvsp[0].ival << 3;}
break;
case 52:
#line 542 "a56.y"
{w0 |= 0x12 | yyvsp[0].ival << 3;}
break;
case 53:
#line 544 "a56.y"
{w0 |= 0x13 | yyvsp[0].ival << 3;}
break;
case 54:
#line 546 "a56.y"
{w0 |= 0x16 | yyvsp[0].ival << 3;}
break;
case 55:
#line 548 "a56.y"
{w0 |= 0x17 | yyvsp[0].ival << 3;}
break;
case 56:
#line 551 "a56.y"
{w0 |= 0x02 | yyvsp[0].ival << 3;}
break;
case 57:
#line 553 "a56.y"
{w0 |= 0x03 | yyvsp[0].ival << 3;}
break;
case 58:
#line 555 "a56.y"
{w0 |= 0x06 | yyvsp[0].ival << 3;}
break;
case 59:
#line 558 "a56.y"
{w0 |= 0x46 | yyvsp[0].ival << 3;}
break;
case 60:
#line 560 "a56.y"
{w0 |= 0x42 | yyvsp[0].ival << 3;}
break;
case 61:
#line 562 "a56.y"
{w0 |= 0x43 | yyvsp[0].ival << 3;}
break;
case 62:
#line 565 "a56.y"
{w0 |= 0x22 | yyvsp[0].ival << 3;}
break;
case 63:
#line 567 "a56.y"
{w0 |= 0x23 | yyvsp[0].ival << 3;}
break;
case 64:
#line 569 "a56.y"
{w0 |= 0x26 | yyvsp[0].ival << 3;}
break;
case 65:
#line 571 "a56.y"
{w0 |= 0x27 | yyvsp[0].ival << 3;}
break;
case 66:
#line 574 "a56.y"
{w0 |= 0x32 | yyvsp[0].ival << 3;}
break;
case 67:
#line 576 "a56.y"
{w0 |= 0x33 | yyvsp[0].ival << 3;}
break;
case 68:
#line 578 "a56.y"
{w0 |= 0x36 | yyvsp[0].ival << 3;}
break;
case 69:
#line 580 "a56.y"
{w0 |= 0x37 | yyvsp[0].ival << 3;}
break;
case 70:
#line 583 "a56.y"
{w0 |= 0x21 | yyvsp[0].ival << 3;}
break;
case 71:
#line 585 "a56.y"
{w0 |= 0x25 | yyvsp[0].ival << 3;}
break;
case 72:
#line 589 "a56.y"
{yyval.ival = yyvsp[-3].ival | yyvsp[0].ival << 1 | yyvsp[-2].ival << 2;}
break;
case 73:
#line 594 "a56.y"
{yyval.ival = 0;}
break;
case 74:
#line 596 "a56.y"
{yyval.ival = 1;}
break;
case 75:
#line 598 "a56.y"
{yyval.ival = 0;}
break;
case 76:
#line 603 "a56.y"
{switch (yyvsp[-2].ival << 4 | yyvsp[0].ival) {
				case 0x00: yyval.ival = 0x0; break;
				case 0x01: 
				case 0x10: yyval.ival = 0x2; break;
				case 0x11: 
					yyerror("illegal source operands"); 
					break;
			}}
break;
case 77:
#line 612 "a56.y"
{switch (yyvsp[-2].ival << 4 | yyvsp[0].ival) {
				case 0x00: yyval.ival = 0x1; break;
				case 0x01: 
				case 0x10: yyval.ival = 0x3; break;
				case 0x11: 
					yyerror("illegal source operands"); 
					break;
			}}
break;
case 78:
#line 621 "a56.y"
{switch (yyvsp[-2].ival << 4 | yyvsp[0].ival) {
				case 0x00: yyval.ival = 0x5; break;
				case 0x01: yyval.ival = 0x4; break;
				case 0x10: yyval.ival = 0x6; break;
				case 0x11: yyval.ival = 0x7; break;
			}}
break;
case 79:
#line 628 "a56.y"
{switch (yyvsp[-2].ival << 4 | yyvsp[0].ival) {
				case 0x00: yyval.ival = 0x5; break;
				case 0x01: yyval.ival = 0x6; break;
				case 0x10: yyval.ival = 0x4; break;
				case 0x11: yyval.ival = 0x7; break;
			}}
break;
case 80:
#line 637 "a56.y"
{yyval.ival = 0x2;}
break;
case 81:
#line 639 "a56.y"
{yyval.ival = 0x3;}
break;
case 82:
#line 641 "a56.y"
{yyval.ival = 0x4 | yyvsp[0].ival;}
break;
case 83:
#line 643 "a56.y"
{yyval.ival = 0x6 | yyvsp[0].ival;}
break;
case 84:
#line 645 "a56.y"
{yyval.ival = 0x8 | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 85:
#line 647 "a56.y"
{yyval.ival = 0xA | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 86:
#line 651 "a56.y"
{yyval.ival = 0x0;}
break;
case 87:
#line 653 "a56.y"
{yyval.ival = 0x1;}
break;
case 88:
#line 655 "a56.y"
{yyval.ival = 0x8 | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 89:
#line 657 "a56.y"
{yyval.ival = 0xA | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 90:
#line 661 "a56.y"
{yyval.ival = 0x0;}
break;
case 91:
#line 663 "a56.y"
{yyval.ival = 0x1;}
break;
case 92:
#line 665 "a56.y"
{yyval.ival = 0x0;}
break;
case 93:
#line 667 "a56.y"
{yyval.ival = 0x1;}
break;
case 94:
#line 671 "a56.y"
{yyval.ival = yyvsp[0].ival;}
break;
case 95:
#line 675 "a56.y"
{yyval.ival = 0x0 | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 96:
#line 677 "a56.y"
{yyval.ival = 0x2 | yyvsp[-2].ival << 2 | yyvsp[0].ival;}
break;
case 97:
#line 681 "a56.y"
{yyval.ival = yyvsp[0].ival;}
break;
case 98:
#line 685 "a56.y"
{yyval.ival = yyvsp[0].ival;}
break;
case 99:
#line 689 "a56.y"
{yyval.ival = 0x0 | yyvsp[0].ival;}
break;
case 100:
#line 691 "a56.y"
{yyval.ival = 0x2 | yyvsp[0].ival;}
break;
case 101:
#line 695 "a56.y"
{yyval.ival = 0;}
break;
case 102:
#line 697 "a56.y"
{yyval.ival = 1;}
break;
case 103:
#line 702 "a56.y"
{if(just_rep == 1)
				yyerror("instruction not allowed after REP");}
break;
case 107:
#line 713 "a56.y"
{w0 |= 0x01D815 | yyvsp[-2].ival << 8 | yyvsp[0].ival << 3;}
break;
case 108:
#line 715 "a56.y"
{w0 |= 0x018040 | yyvsp[0].ival << 3;}
break;
case 109:
#line 717 "a56.y"
{w0 |= 0x0000F8 | (n2int(yyvsp[-2].n) & 0xFF) << 8 | yyvsp[0].ival;}
break;
case 110:
#line 719 "a56.y"
{w0 |= 0x0000B8 | (n2int(yyvsp[-2].n) & 0xFF) << 8 | yyvsp[0].ival;}
break;
case 115:
#line 734 "a56.y"
{if(yyvsp[0].ival) {
				w0 |= 0x0BC0A0 | yyvsp[-1].cond << 0;
			} else {
				w0 |= 0x0F0000 | yyvsp[-1].cond << 12;
			}}
break;
case 116:
#line 740 "a56.y"
{if(yyvsp[0].ival) {
				w0 |= 0x0AC0A0 | yyvsp[-1].cond << 0;
			} else {
				w0 |= 0x0E0000 | yyvsp[-1].cond << 12;
			}}
break;
case 117:
#line 746 "a56.y"
{if(yyvsp[0].ival) {
				w0 |= 0x0BC080;
			} else {
				w0 |= 0x0D0000;
			}}
break;
case 118:
#line 752 "a56.y"
{if(yyvsp[0].ival) {
				w0 |= 0x0AC080;
			} else {
				w0 |= 0x0C0000;
			}}
break;
case 119:
#line 759 "a56.y"
{w0 |= 0x0B0020;}
break;
case 120:
#line 761 "a56.y"
{w0 |= 0x0B0000;}
break;
case 121:
#line 763 "a56.y"
{w0 |= 0x0A0020;}
break;
case 122:
#line 765 "a56.y"
{w0 |= 0x0A0000;}
break;
case 123:
#line 768 "a56.y"
{just_rep = 2;}
break;
case 124:
#line 770 "a56.y"
{uses_w1++;}
break;
case 125:
#line 772 "a56.y"
{w0 |= 0x00008C;}
break;
case 126:
#line 774 "a56.y"
{w0 |= 0x000087;}
break;
case 127:
#line 776 "a56.y"
{w0 |= 0x000086;}
break;
case 128:
#line 778 "a56.y"
{w0 |= 0x000084;}
break;
case 129:
#line 780 "a56.y"
{w0 |= 0x00000C;}
break;
case 130:
#line 782 "a56.y"
{w0 |= 0x000006;}
break;
case 131:
#line 784 "a56.y"
{w0 |= 0x000005;}
break;
case 132:
#line 786 "a56.y"
{w0 |= 0x000004;}
break;
case 133:
#line 788 "a56.y"
{w0 |= 0x000000;
			just_rep = 0;}
break;
case 134:
#line 793 "a56.y"
{int ival = n2int(yyvsp[-2].n);
			w0 |= 0x060080 | (ival & 0xFF) << 8 | (ival & 0xF00)>> 8;
			if(ival > 0xFFF && pass == 2) {
				yyerror("warning: immediate operand truncated");
			}
			w1 |= yyvsp[0].ival-1;}
break;
case 135:
#line 800 "a56.y"
{w0 |= 0x06C000 | yyvsp[-2].regs.r6 << 8;
			w1 |= yyvsp[0].ival-1;}
break;
case 136:
#line 803 "a56.y"
{w0 |= 0x064000 | yyvsp[-2].ival << 8 | yyvsp[-3].ival << 6;
			w1 |= yyvsp[0].ival-1;}
break;
case 137:
#line 806 "a56.y"
{w0 |= 0x060000 | (yyvsp[-2].ival & 0x3F) << 8 | yyvsp[-3].ival << 6;
			if(yyvsp[-2].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w1 |= yyvsp[0].ival-1;}
break;
case 138:
#line 811 "a56.y"
{w0 |= 0x060000 | (yyvsp[-2].ival & 0x3F) << 8 | yyvsp[-3].ival << 6;
			if(yyvsp[-2].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w1 |= yyvsp[0].ival-1;}
break;
case 139:
#line 819 "a56.y"
{int ival = n2int(yyvsp[0].n);
			w0 |= 0x0600A0 | (ival & 0xFF) << 8 | (ival & 0xF00)>> 8;
			if(ival > 0xFFF && pass == 2) {
				yyerror("warning: immediate operand truncated");
			}}
break;
case 140:
#line 825 "a56.y"
{w0 |= 0x06C020 | yyvsp[0].regs.r6 << 8;}
break;
case 141:
#line 827 "a56.y"
{w0 |= 0x064020 | yyvsp[-1].ival << 6 | yyvsp[0].ival << 8;}
break;
case 142:
#line 829 "a56.y"
{w0 |= 0x060020 | yyvsp[-1].ival << 6 | (yyvsp[0].ival & 0x3F) << 8;
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 143:
#line 834 "a56.y"
{w0 |= 0x060020 | yyvsp[-1].ival << 6 | (yyvsp[0].ival & 0x3F) << 8;
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 144:
#line 842 "a56.y"
{w0 |= yyvsp[-5].ival << 0 | yyvsp[-3].ival << 6;
			uses_w1++;
			w1 = yyvsp[0].ival;}
break;
case 145:
#line 846 "a56.y"
{w0 |= 0x00C000 | yyvsp[-4].ival << 0 | yyvsp[-2].regs.r6 << 8;
			uses_w1++;
			w1 = yyvsp[0].ival;}
break;
case 146:
#line 858 "a56.y"
{if(yyvsp[0].ival != -1) {	/* symbol defined */
				w0 |= (yyvsp[0].ival & 0x3F) << 8;
				if(yyvsp[0].ival >= 0xFFC0) {
					w0 |= 0x008080;
				} else {
					w0 |= 0x000080;
					if(yyvsp[0].ival > 0x003F && pass == 2)
						yyerror("warning: address operand truncated");
				}
			}}
break;
case 147:
#line 869 "a56.y"
{if(yyvsp[0].ival != -1) {
				if(yyvsp[0].ival > 0x3F && pass == 2)
					yyerror("warning: address operand truncated");
				w0 |= 0x000080 | (yyvsp[0].ival & 0x3F) << 8;
			}}
break;
case 148:
#line 875 "a56.y"
{if(yyvsp[0].ival != -1) {
				if(yyvsp[0].ival < 0xFFC0 && pass == 2)
					yyerror("warning: address operand truncated");
				w0 |= 0x008080 | (yyvsp[0].ival & 0x3F) << 8;
			}}
break;
case 149:
#line 881 "a56.y"
{w0 |= 0x004080 | yyvsp[0].ival << 8;}
break;
case 150:
#line 888 "a56.y"
{w0 |= 0x0B0020;}
break;
case 151:
#line 890 "a56.y"
{w0 |= 0x0B0000;}
break;
case 152:
#line 892 "a56.y"
{w0 |= 0x0A0020;}
break;
case 153:
#line 894 "a56.y"
{w0 |= 0x0A0000;}
break;
case 154:
#line 899 "a56.y"
{w0 |= yyvsp[-3].ival << 0 | yyvsp[-1].ival << 6;}
break;
case 155:
#line 901 "a56.y"
{w0 |= 0x00C040 | yyvsp[-2].ival << 0 | yyvsp[0].regs.r6 << 8;}
break;
case 156:
#line 906 "a56.y"
{if(yyvsp[0].ival != -1) {
				w0 |= (yyvsp[0].ival & 0x3F) << 8 | 0x008000;
				if(yyvsp[0].ival < 0xFFC0 && pass == 2)
					yyerror("warning: address operand truncated");
			}}
break;
case 157:
#line 912 "a56.y"
{if(yyvsp[0].ival != -1) {
				w0 |= (yyvsp[0].ival & 0x3F) << 8 | 0x000000;
				if(yyvsp[0].ival > 0x003F && pass == 2)
					yyerror("warning: address operand truncated");
			}}
break;
case 158:
#line 918 "a56.y"
{w0 |= 0x004000;}
break;
case 162:
#line 928 "a56.y"
{w0 |= 0x044010 | yyvsp[-2].ival << 8 | yyvsp[0].regs.r4;}
break;
case 163:
#line 930 "a56.y"
{w0 |= yyvsp[-1].cond << 12;}
break;
case 164:
#line 935 "a56.y"
{w0 |= 0x020000 | yyvsp[0].ival << 3;}
break;
case 165:
#line 937 "a56.y"
{w0 |= 0x030000 | yyvsp[-3].ival << 3 | yyvsp[-2].ival << 8 | yyvsp[0].ival;}
break;
case 166:
#line 941 "a56.y"
{if(yyvsp[-2].regs.flags & R_AB && yyvsp[0].regs.flags & R_AB) {
				if(yyvsp[-2].regs.ab == yyvsp[0].regs.ab) 
					yyerror("source and dest must be different");
				yyval.ival = yyvsp[0].regs.ab;
			} else if(yyvsp[-2].regs.flags & R_XREG && yyvsp[0].regs.flags & R_AB) {
				yyval.ival = 0x8 | yyvsp[-2].regs.xreg << 2 | yyvsp[0].regs.ab;
			} else if(yyvsp[-2].regs.flags & R_YREG && yyvsp[0].regs.flags & R_AB) {
				yyval.ival = 0xA | yyvsp[-2].regs.yreg << 2 | yyvsp[0].regs.ab;
			} else 
				yyerror("illegal TCC operands");
			}
break;
case 167:
#line 955 "a56.y"
{if(yyvsp[-2].regs.flags & R_XREG && yyvsp[0].regs.flags & R_AB) {
				yyval.ival = yyvsp[-2].regs.xreg << 2 | yyvsp[0].regs.ab;
			} else if(yyvsp[-2].regs.flags & R_YREG && yyvsp[0].regs.flags & R_AB) {
				yyval.ival = yyvsp[-2].regs.yreg << 2 | 2 | yyvsp[0].regs.ab;
			}}
break;
case 168:
#line 964 "a56.y"
{if(NOT (yyvsp[0].regs.flags & R_CTL_REG))
				yyerror("bad MOVEC target register");
			if(yyvsp[-3].ival == 0) {
				w0 |= 0x05C020 | yyvsp[0].regs.ctl_reg;
			} else {
				w0 |= 0x05C060 | yyvsp[0].regs.ctl_reg;
			}}
break;
case 169:
#line 972 "a56.y"
{if(NOT (yyvsp[-3].regs.flags & R_CTL_REG))
				yyerror("bad MOVEC source register");
			if(yyvsp[-1].ival == 0) {
				w0 |= 0x054020 | yyvsp[-3].regs.ctl_reg;
			} else {
				w0 |= 0x054060 | yyvsp[-3].regs.ctl_reg;
			}}
break;
case 170:
#line 980 "a56.y"
{int ival = n2int(yyvsp[-2].n);
			if(NOT (yyvsp[0].regs.flags & R_CTL_REG))
				yyerror("bad MOVEC target register");
			if(ival < 256 && NOT long_symbolic_expr) {
				w0 |= 0x0500A0 | (ival & 0xFF) << 8 | yyvsp[0].regs.ctl_reg; 
			} else {
				w0 |= 0x05C020 | 0x003400 | yyvsp[0].regs.ctl_reg;
				uses_w1++; w1 = ival;
			}}
break;
case 171:
#line 990 "a56.y"
{if(yyvsp[-3].ival == 0) {
				w0 |= 0x058020 | (yyvsp[-2].ival & 0x3F) << 8 | yyvsp[0].regs.ctl_reg;
			} else {
				w0 |= 0x058060 | (yyvsp[-2].ival & 0x3F) << 8 | yyvsp[0].regs.ctl_reg;
			}
			if(NOT (yyvsp[0].regs.flags & R_CTL_REG))
				yyerror("bad MOVEC target register");
			if(yyvsp[-2].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 172:
#line 1001 "a56.y"
{if(yyvsp[-1].ival == 0) {
				w0 |= 0x050020 | (yyvsp[0].ival & 0x3F) << 8 | yyvsp[-3].regs.ctl_reg;
			} else {
				w0 |= 0x050060 | (yyvsp[0].ival & 0x3F) << 8 | yyvsp[-3].regs.ctl_reg;
			}
			if(NOT (yyvsp[-3].regs.flags & R_CTL_REG))
				yyerror("bad MOVEC source register");
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 173:
#line 1012 "a56.y"
{if(yyvsp[-2].regs.flags & R_CTL_REG) {
				w0 |= 0x0440A0 | yyvsp[0].regs.r6 << 8 | yyvsp[-2].regs.ctl_reg;
			} else if(yyvsp[0].regs.flags & R_CTL_REG) {
				w0 |= 0x04C0A0 | yyvsp[-2].regs.r6 << 8 | yyvsp[0].regs.ctl_reg;
			} else if(yyvsp[-2].regs.flags & yyvsp[0].regs.flags & R_CTL_REG) {
				/* bogus? $$$ */
	       			w0 |= 0x04C0A0 | (yyvsp[-2].regs.ctl_reg | 0x20) << 8 | 
				yyvsp[0].regs.ctl_reg;
			} else {
				yyerror("MOVEC must reference a control reg");
			}}
break;
case 174:
#line 1027 "a56.y"
{w0 |= 0x084080;
			switch(yyvsp[-3].ea.pp << 1 | yyvsp[0].ea.pp) {
				case 0:	case 3:
					yyerror("illegal MOVEP; can't move EA to EA or IO to IO");
					break;
				case 1:	/* ea, pp */
					w0 |= yyvsp[-1].ival << 16 | 1 << 15 | yyvsp[-4].ival << 6 |
						(yyvsp[0].ea.ext & 0x3F);
					if(yyvsp[-3].ea.mode == 0x003000) {
						w0 |= 0x003000;
						uses_w1++;
						w1 = yyvsp[-3].ea.ext;
					} else {
						w0 |= yyvsp[-3].ea.mode;
					}
					break;
				case 2:	/* pp, ea */
					w0 |= yyvsp[-4].ival << 16 | 0 << 15 | yyvsp[-1].ival << 6 |
						(yyvsp[-3].ea.ext & 0x3F);
					if(yyvsp[0].ea.mode == 0x003000) {
						w0 |= 0x003000;
						uses_w1++;
						w1 = yyvsp[0].ea.ext;
					} else {
						w0 |= yyvsp[0].ea.mode;
					}
					break;
			}}
break;
case 175:
#line 1056 "a56.y"
{w0 |= 0x084080;
			w0 |= yyvsp[-1].ival << 16 | 1 << 15 | 0x34 << 8 | 
				(n2int(yyvsp[0].n) & 0x3F);
			uses_w1++;
			w1 = n2int(yyvsp[-3].n);}
break;
case 176:
#line 1062 "a56.y"
{w0 |= 0x084040;
			w0 |= yyvsp[-1].ival << 16 | 1 << 15 | (n2int(yyvsp[0].n) & 0x3F);}
break;
case 177:
#line 1065 "a56.y"
{w0 |= 0x084040;
			if(yyvsp[-3].ea.mode != 0x003000 && yyvsp[-3].ea.mode != 0)
				yyerror("illegal MOVEP");
			w0 |= yyvsp[-4].ival << 16 | 0 << 15 | (yyvsp[-3].ea.ext & 0x3F);}
break;
case 178:
#line 1070 "a56.y"
{w0 |= 0x084000;
			w0 |= yyvsp[-1].ival << 16 | 1 << 15 | yyvsp[-3].regs.r6 << 8 | 
				(n2int(yyvsp[0].n) & 0x3F);}
break;
case 179:
#line 1074 "a56.y"
{w0 |= 0x084000;
			if(!yyvsp[-2].ea.pp)
				yyerror("illegal MOVEP");
			w0 |= yyvsp[-3].ival << 16 | 0 << 15 | yyvsp[0].regs.r6 << 8 | (yyvsp[-2].ea.ext & 0x3F);}
break;
case 180:
#line 1082 "a56.y"
{if(yyvsp[0].ival != UNDEF && yyvsp[0].ival >= 0xFFC0) {
				/* defined symbol or constant, in i/o range */
				yyval.ea.pp = 1;
				yyval.ea.mode = 0;
			} else {
				/* either out of i/o range or symbol not */
				/* yet defined:  assume ea extension */
				yyval.ea.pp = 0;
				yyval.ea.mode = 0x003000;
			}
			yyval.ea.ext = yyvsp[0].ival;}
break;
case 181:
#line 1094 "a56.y"
{yyval.ea.pp = 1;
			yyval.ea.mode = 0;
			if(yyvsp[0].ival < 0xFFC0 && pass == 2)
				yyerror("warning: address operand truncated");
			yyval.ea.ext = yyvsp[0].ival;}
break;
case 182:
#line 1100 "a56.y"
{yyval.ea.pp = 0;
			yyval.ea.mode = yyvsp[0].ival << 8;
			yyval.ea.ext = yyvsp[0].ival;}
break;
case 183:
#line 1107 "a56.y"
{w0 |= 0x070000 | 0 << 15 | yyvsp[-3].regs.r6;}
break;
case 184:
#line 1109 "a56.y"
{w0 |= 0x070000 | 1 << 15 | yyvsp[0].regs.r6;}
break;
case 185:
#line 1116 "a56.y"
{int ival = n2int(yyvsp[0].n);
			yyval.ival = ival; if(ival > 0x17) 
				yyerror("%d: illegal bit number", ival);}
break;
case 186:
#line 1122 "a56.y"
{yyval.ival = 0;}
break;
case 187:
#line 1124 "a56.y"
{yyval.ival = 1;}
break;
case 188:
#line 1130 "a56.y"
{w0 |= 0x004080;}
break;
case 189:
#line 1132 "a56.y"
{w0 |= (yyvsp[0].ival & 0x3F) << 8;
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 190:
#line 1139 "a56.y"
{yyval.ival = 1;}
break;
case 191:
#line 1141 "a56.y"
{w0 |= yyvsp[0].ival & 0xFFF; yyval.ival = 0;
			if(yyvsp[0].ival > 0x0FFF && pass == 2)
				yyerror("warning: address operand truncated");
			}
break;
case 192:
#line 1148 "a56.y"
{w0 |= 0x003000;
			uses_w1++;
			w1 |= yyvsp[0].ival;
			yyval.ival = 0x003000;}
break;
case 193:
#line 1153 "a56.y"
{w0 |= yyvsp[0].ival << 8;
			yyval.ival = yyvsp[0].ival << 8;}
break;
case 194:
#line 1159 "a56.y"
{yyval.ival = yyvsp[0].ival;}
break;
case 195:
#line 1161 "a56.y"
{yyval.ival = 4 << 3 | yyvsp[-1].ival;}
break;
case 196:
#line 1163 "a56.y"
{yyval.ival = 5 << 3 | yyvsp[-3].ival;
			if(yyvsp[-3].ival != yyvsp[-1].ival) yyerror("Rn and Nn must be same number");}
break;
case 197:
#line 1166 "a56.y"
{yyval.ival = 7 << 3 | yyvsp[-1].ival;}
break;
case 198:
#line 1171 "a56.y"
{yyval.ival = 0 << 3 | yyvsp[-3].ival;
			if(yyvsp[-3].ival != yyvsp[0].ival) yyerror("Rn and Nn must be same number");}
break;
case 199:
#line 1174 "a56.y"
{yyval.ival = 1 << 3 | yyvsp[-3].ival;
			if(yyvsp[-3].ival != yyvsp[0].ival) yyerror("Rn and Nn must be same number");}
break;
case 200:
#line 1177 "a56.y"
{yyval.ival = 2 << 3 | yyvsp[-2].ival;}
break;
case 201:
#line 1179 "a56.y"
{yyval.ival = 3 << 3 | yyvsp[-2].ival;}
break;
case 202:
#line 1185 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x04 | yyvsp[0].ival;
			yyval.regs.sdx = yyvsp[0].ival;
			yyval.regs.xreg = yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_XREG|R_SDX|R_SFRAC;}
break;
case 203:
#line 1190 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x06 | yyvsp[0].ival;
			yyval.regs.sdy = yyvsp[0].ival;
			yyval.regs.yreg = yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_SDY|R_YREG|R_SFRAC;}
break;
case 204:
#line 1195 "a56.y"
{switch(yyvsp[0].ival) {
				case 0: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 0; 
					break;
				case 1: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 4; 
					break;
				case 2: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 2; 
					break;
			}
			yyval.regs.flags = R_R6|R_R5|R_UINT;}
break;
case 205:
#line 1208 "a56.y"
{switch(yyvsp[0].ival) {
				case 0: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 1; break;
				case 1: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 5; break;
				case 2: 
					yyval.regs.r6 = yyval.regs.r5 = 0x08 | 3; break;
			}
			yyval.regs.flags = R_R6|R_R5|R_UINT;}
break;
case 206:
#line 1218 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x0E;
			yyval.regs.sdx = yyval.regs.sdy = 0x2;
			yyval.regs.ab = 0;
			yyval.regs.lsd = 4;
			yyval.regs.flags = R_R6|R_R5|R_SDX|R_SDY|R_AB|R_LSD|R_SFRAC;}
break;
case 207:
#line 1224 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x0F;
			yyval.regs.sdx = yyval.regs.sdy = 0x3;
			yyval.regs.ab = 1;
			yyval.regs.lsd = 5;
			yyval.regs.flags = R_R6|R_R5|R_SDX|R_SDY|R_AB|R_LSD|R_SFRAC;}
break;
case 208:
#line 1230 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x10 | yyvsp[0].ival;
			yyval.regs.r4 = 0x00 | yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_R4|R_UINT;}
break;
case 209:
#line 1234 "a56.y"
{yyval.regs.r6 = yyval.regs.r5 = 0x18 | yyvsp[0].ival;
			yyval.regs.r4 = 0x08 | yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_R4|R_UINT;}
break;
case 210:
#line 1238 "a56.y"
{yyval.regs.r6 = 0x20 | yyvsp[0].ival;
			yyval.regs.r5 = -1;
			yyval.regs.ctl_reg = yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_CTL_REG|R_UINT;}
break;
case 211:
#line 1243 "a56.y"
{yyval.regs.r6 = 0x38 | yyvsp[0].ival;
			yyval.regs.r5 = -1;
			yyval.regs.ctl_reg = 0x18 | yyvsp[0].ival;
			yyval.regs.flags = R_R6|R_R5|R_CTL_REG|R_UINT;}
break;
case 212:
#line 1248 "a56.y"
{yyval.regs.lsd  = 0;
			yyval.regs.flags = R_LSD;}
break;
case 213:
#line 1251 "a56.y"
{yyval.regs.lsd = 1;
			yyval.regs.flags = R_LSD;}
break;
case 214:
#line 1254 "a56.y"
{yyval.regs.lsd = 2;
			yyval.regs.flags = R_LSD;}
break;
case 215:
#line 1257 "a56.y"
{yyval.regs.lsd = 3;
			yyval.regs.flags = R_LSD;}
break;
case 216:
#line 1260 "a56.y"
{yyval.regs.lsd = 6;
			yyval.regs.flags = R_LSD;}
break;
case 217:
#line 1263 "a56.y"
{yyval.regs.lsd = 7;
			yyval.regs.flags = R_LSD;}
break;
case 218:
#line 1269 "a56.y"
{yyval.ival = 1;}
break;
case 219:
#line 1271 "a56.y"
{yyval.ival = 2;}
break;
case 220:
#line 1273 "a56.y"
{yyval.ival = 3;}
break;
case 221:
#line 1275 "a56.y"
{yyval.ival = 4;}
break;
case 222:
#line 1277 "a56.y"
{yyval.ival = 5;}
break;
case 223:
#line 1279 "a56.y"
{yyval.ival = 6;}
break;
case 224:
#line 1281 "a56.y"
{yyval.ival = 7;}
break;
case 225:
#line 1286 "a56.y"
{yyval.ival = 0;}
break;
case 226:
#line 1288 "a56.y"
{yyval.ival = 1;}
break;
case 227:
#line 1290 "a56.y"
{yyval.ival = 2;}
break;
case 236:
#line 1307 "a56.y"
{int ival = n2int(yyvsp[-2].n);
			int frac = n2frac(yyvsp[-2].n);
			int value;
			BOOL shortform = FALSE;
			if(yyvsp[0].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			if((yyvsp[0].regs.flags & R_SFRAC) && yyvsp[-2].n.type == FLT) {
				if((frac & 0xFFFF) == 0 && 
					NOT long_symbolic_expr) {
					value = frac >> 16;
					shortform++;
				} else {
					value = frac;
				}
			} else {
				if(ival <= 0xFF && ival >= -0xFF && NOT long_symbolic_expr) {
					value = ival;
					shortform++;
				} else {
					value = ival;
				}
			}

			if(shortform) {
				w0 |= 0x200000 | (value & 0xFF) << 8 |
					yyvsp[0].regs.r5 << 16;
			} else {
				w0 |= 0x400000 | 0x00F400 |
					(yyvsp[0].regs.r5 >> 3 & 3) << 20 | 
					(yyvsp[0].regs.r5 & 7) << 16;
				uses_w1++; w1 = value;
			}}
break;
case 237:
#line 1344 "a56.y"
{     /* GGeiger test */
				if((yyvsp[0].regs.flags & R_CTL_REG) || (yyvsp[-2].regs.flags & R_CTL_REG)) {
					yyerror("please use MOVEC for control register moves");
					break;
				}
				if(yyvsp[-2].regs.flags & R_R5 & yyvsp[0].regs.flags) 
					w0 |= 0x200000 | yyvsp[0].regs.r5 << 8 | yyvsp[-2].regs.r5 << 13;
				else
					yyerror("illegal R move");
			}
break;
case 238:
#line 1357 "a56.y"
{w0 |= 0x204000 | yyvsp[0].ival << 8;}
break;
case 239:
#line 1362 "a56.y"
{w0 |= 0x40C000 | yyvsp[-3].ival << 19;
			if(yyvsp[0].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			w0 |= (yyvsp[0].regs.r5 >> 3 & 3) << 20 | (yyvsp[0].regs.r5 & 7) << 16;}
break;
case 240:
#line 1369 "a56.y"
{w0 |= 0x408000 | yyvsp[-3].ival << 19 | (yyvsp[-2].ival & 0x3F) << 8;
			if(yyvsp[0].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			if(yyvsp[-2].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w0 |= (yyvsp[0].regs.r5>> 3 & 3) << 20 | (yyvsp[0].regs.r5 & 7) << 16;}
break;
case 241:
#line 1378 "a56.y"
{w0 |= 0x404000 | yyvsp[-1].ival << 19;
			if(yyvsp[-3].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			w0 |= (yyvsp[-3].regs.r5 >> 3 & 3) << 20 | (yyvsp[-3].regs.r5 & 7) << 16;}
break;
case 242:
#line 1385 "a56.y"
{w0 |= 0x400000 | yyvsp[-1].ival << 19 | (yyvsp[0].ival & 0x3F) << 8;
			if(yyvsp[-3].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w0 |= (yyvsp[-3].regs.r5 >> 3 & 3) << 20 | (yyvsp[-3].regs.r5 & 7) << 16;}
break;
case 243:
#line 1396 "a56.y"
{if(yyvsp[-6].ival == 0 && yyvsp[-2].regs.flags & R_AB) {
				w0 |= 0x108000 | yyvsp[-3].regs.sdx << 18 | yyvsp[-2].regs.ab << 17 |
					yyvsp[0].ival << 16;
			} else {
				yyerror("illegal X:R move");
			}}
break;
case 244:
#line 1403 "a56.y"
{if(yyvsp[-2].regs.flags & R_AB) {
				w0 |= 0x10B400 | yyvsp[-3].regs.sdx << 18 | yyvsp[-2].regs.ab << 17 |
					yyvsp[0].ival << 16;
				uses_w1++;
				w1 |= n2frac(yyvsp[-5].n) & 0xFFFFFF;
			} else {
				yyerror("illegal X:R move");
			}}
break;
case 245:
#line 1412 "a56.y"
{if(yyvsp[-6].regs.flags & R_SDX && yyvsp[-4].ival == 0 && yyvsp[-2].regs.flags & R_AB &&
				yyvsp[0].regs.flags & R_YREG) {
				w0 |= 0x100000 | yyvsp[-6].regs.sdx << 18 | yyvsp[-2].regs.ab << 17 |
					yyvsp[0].regs.yreg << 16;
			} else if(yyvsp[-6].regs.flags & R_AB && yyvsp[-4].ival == 0 && 
				yyvsp[-2].regs.flags & R_XREG && yyvsp[0].regs.flags & R_AB) {
				if(yyvsp[-2].regs.xreg != 0) yyerror("must use X0");
				if(yyvsp[-6].regs.ab == 0 && yyvsp[0].regs.ab == 0)
					w0 |= 0x080000;
				else if(yyvsp[-6].regs.ab == 1 && yyvsp[0].regs.ab == 1)
					w0 |= 0x090000;
				else
					yyerror("illegal X:R move");
			} else {
				yyerror("illegal X:R move");
			}}
break;
case 246:
#line 1431 "a56.y"
{if(yyvsp[-4].regs.flags & R_XREG && yyvsp[0].regs.flags & (R_YREG|R_AB)) {
				w0 |= 0x10C000 | yyvsp[-6].regs.ab << 19 | yyvsp[-4].regs.xreg << 18 |
					yyvsp[0].regs.sdy << 16;
			} else {
				yyerror("illegal R:Y move");
			}}
break;
case 247:
#line 1438 "a56.y"
{if(yyvsp[-3].regs.flags & R_XREG && yyvsp[0].regs.flags & (R_YREG|R_AB)) {
				w0 |= 0x10F400 | yyvsp[-5].regs.ab << 19 | yyvsp[-3].regs.xreg << 18 |
					yyvsp[0].regs.sdy << 16;
				uses_w1++;
				w1 |= n2frac(yyvsp[-2].n) & 0xFFFFFF;
			} else {
				yyerror("illegal R:Y move");
			}}
break;
case 248:
#line 1447 "a56.y"
{if(yyvsp[-6].regs.flags & R_AB && yyvsp[-4].regs.flags & R_XREG) {
				w0 |= 0x104000 | yyvsp[-6].regs.ab << 19 | yyvsp[-4].regs.xreg << 18 |
				yyvsp[-3].regs.sdy << 16;
			} else if (yyvsp[-6].regs.flags & R_YREG && yyvsp[-4].regs.flags & R_AB &&
				yyvsp[-3].regs.flags & R_AB) {
				if(yyvsp[-6].regs.yreg != 0) yyerror("must use Y0");
				if(yyvsp[-4].regs.ab == 0 && yyvsp[-3].regs.ab == 0)
					w0 |= 0x088000;
				else if(yyvsp[-4].regs.ab == 1 && yyvsp[-3].regs.ab == 1)
					w0 |= 0x098000;
				else
					yyerror("illegal R:Y move");
			} else {
				yyerror("illegal R:Y move");
			}}
break;
case 249:
#line 1465 "a56.y"
{if(yyvsp[0].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			w0 |= 0x40C000 | (yyvsp[0].regs.lsd & 3) << 16 | (yyvsp[0].regs.lsd >> 2) << 19;}
break;
case 250:
#line 1471 "a56.y"
{if(yyvsp[-3].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			w0 |= 0x404000 | (yyvsp[-3].regs.lsd & 3) << 16 | (yyvsp[-3].regs.lsd >> 2) << 19;}
break;
case 251:
#line 1477 "a56.y"
{w0 |= 0x408000 | (yyvsp[0].regs.lsd & 3) << 16 | (yyvsp[0].regs.lsd >> 2) << 19;
			if(yyvsp[0].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			if(yyvsp[-2].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w0 |= (yyvsp[-2].ival & 0x3F) << 8;}
break;
case 252:
#line 1486 "a56.y"
{w0 |= 0x400000 | (yyvsp[-3].regs.lsd & 3) << 16 | (yyvsp[-3].regs.lsd >> 2) << 19;
			if(yyvsp[-3].regs.flags & R_CTL_REG) {
				yyerror("please use MOVEC for control register moves");
				break;
			}
			if(yyvsp[0].ival > 0x003F && pass == 2)
				yyerror("warning: address operand truncated");
			w0 |= (yyvsp[0].ival & 0x3F) << 8;}
break;
case 253:
#line 1497 "a56.y"
{int eax = yyvsp[-6].ival, eay = yyvsp[-2].ival,
			     regx = (yyvsp[-4].regs.flags & R_AB) ? yyvsp[-4].regs.ab | 2 : yyvsp[-4].regs.xreg,
			     regy = (yyvsp[0].regs.flags & R_AB) ? yyvsp[0].regs.ab | 2 : yyvsp[0].regs.yreg;
			if((eax & 0x400) == (eay & 0x400))
				yyerror("registers must be in opposite halves");
			if(!(yyvsp[-4].regs.flags & (R_AB | R_XREG)))
				yyerror("invalid X move register");
			if(!(yyvsp[0].regs.flags & (R_AB | R_YREG)))
				yyerror("invalid Y move register");
			if(yyvsp[-4].regs.flags & R_AB &&
			   yyvsp[0].regs.flags & R_AB &&
			   yyvsp[-4].regs.ab == yyvsp[0].regs.ab)
				yyerror("duplicate destination register");
			w0 = w0 & 0xFF | 0xC08000;	/* both write */
			w0 |= eax & 0x1f00 | (eay & 0x300) << 5 | (eay & 0x1800) << 9 | regx << 18 | regy << 16;}
break;
case 254:
#line 1513 "a56.y"
{int eax = yyvsp[-6].ival, eay = yyvsp[0].ival,
			     regx = (yyvsp[-4].regs.flags & R_AB) ? yyvsp[-4].regs.ab | 2 : yyvsp[-4].regs.xreg,
			     regy = (yyvsp[-3].regs.flags & R_AB) ? yyvsp[-3].regs.ab | 2 : yyvsp[-3].regs.yreg;
			if((eax & 0x400) == (eay & 0x400))
				yyerror("registers must be in opposite halves");
			if(!(yyvsp[-4].regs.flags & (R_AB | R_XREG)))
				yyerror("invalid X move register");
			if(!(yyvsp[-3].regs.flags & (R_AB | R_YREG)))
				yyerror("invalid Y move register");
			w0 = w0 & 0xFF | 0x808000;	/* X:write, Y:read */
			w0 |= eax & 0x1f00 | (eay & 0x300) << 5 | (eay & 0x1800) << 9 | regx << 18 | regy << 16;}
break;
case 255:
#line 1525 "a56.y"
{int eax = yyvsp[-4].ival, eay = yyvsp[-2].ival,
			     regx = (yyvsp[-7].regs.flags & R_AB) ? yyvsp[-7].regs.ab | 2 : yyvsp[-7].regs.xreg,
			     regy = (yyvsp[0].regs.flags & R_AB) ? yyvsp[0].regs.ab | 2 : yyvsp[0].regs.yreg;
			if((eax & 0x400) == (eay & 0x400))
				yyerror("registers must be in opposite halves");
			if(!(yyvsp[-7].regs.flags & (R_AB | R_XREG)))
				yyerror("invalid X move register");
			if(!(yyvsp[0].regs.flags & (R_AB | R_YREG)))
				yyerror("invalid Y move register");
	      		w0 = w0 & 0xFF | 0xC00000;	/* X:read, Y:write */
			w0 |= eax & 0x1f00 | (eay & 0x300) << 5 | (eay & 0x1800) << 9 | regx << 18 | regy << 16;}
break;
case 256:
#line 1537 "a56.y"
{int eax = yyvsp[-4].ival, eay = yyvsp[0].ival,
			     regx = (yyvsp[-7].regs.flags & R_AB) ? yyvsp[-7].regs.ab | 2 : yyvsp[-7].regs.xreg,
			     regy = (yyvsp[-3].regs.flags & R_AB) ? yyvsp[-3].regs.ab | 2 : yyvsp[-3].regs.yreg;
			if((eax & 0x400) == (eay & 0x400))
				yyerror("registers must be in opposite halves");
			if(!(yyvsp[-7].regs.flags & (R_AB | R_XREG)))
				yyerror("invalid X move register");
			if(!(yyvsp[-3].regs.flags & (R_AB | R_YREG)))
				yyerror("invalid Y move register");
	      		w0 = w0 & 0xFF | 0x800000;	/* both read */
			w0 |= eax & 0x1f00 | (eay & 0x300) << 5 | (eay & 0x1800) << 9 | regx << 18 | regy << 16;}
break;
case 257:
#line 1553 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 258:
#line 1555 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 259:
#line 1557 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 260:
#line 1561 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 261:
#line 1563 "a56.y"
{yyval.n = yyvsp[0].n;
			long_symbolic_expr = TRUE;}
break;
case 262:
#line 1566 "a56.y"
{yyval.n.val.i = n2int(yyvsp[0].n) & 0xFF;
			yyval.n.type = INT;
			long_symbolic_expr = FALSE;}
break;
case 263:
#line 1573 "a56.y"
{yyval.ival = n2int(yyvsp[0].n);}
break;
case 264:
#line 1575 "a56.y"
{yyval.ival = n2int(yyvsp[0].n);}
break;
case 265:
#line 1580 "a56.y"
{yyval.ival = n2int(yyvsp[0].n);}
break;
case 266:
#line 1585 "a56.y"
{yyval.ival = n2int(yyvsp[0].n);}
break;
case 267:
#line 1590 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 268:
#line 1592 "a56.y"
{yyval.n = sym_ref(yyvsp[0].sval); free(yyvsp[0].sval);}
break;
case 269:
#line 1594 "a56.y"
{yyval.n.type = INT; yyval.n.val.i = yyvsp[0].ival;}
break;
case 270:
#line 1599 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
case 271:
#line 1601 "a56.y"
{yyval.n = sym_ref(yyvsp[0].sval); free(yyvsp[0].sval); long_symbolic_expr++;}
break;
case 272:
#line 1603 "a56.y"
{yyval.n.type = INT; yyval.n.val.i = yyvsp[0].cval & 0xFFFFFF;}
break;
case 273:
#line 1605 "a56.y"
{yyval.n.type = INT; yyval.n.val.i = pc;}
break;
case 274:
#line 1610 "a56.y"
{yyval.n.type = INT; 
				if(yyvsp[-1].n.type == INT)
					yyval.n.val.i = yyvsp[-1].n.val.i;
				else
					yyval.n.val.i = yyvsp[-1].n.val.f;
			}
break;
case 275:
#line 1617 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '|', yyvsp[0].n);}
break;
case 276:
#line 1619 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '^', yyvsp[0].n);}
break;
case 277:
#line 1621 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '&', yyvsp[0].n);}
break;
case 278:
#line 1623 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, SHR, yyvsp[0].n);}
break;
case 279:
#line 1625 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, SHL, yyvsp[0].n);}
break;
case 280:
#line 1627 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '-', yyvsp[0].n);}
break;
case 281:
#line 1629 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '+', yyvsp[0].n);}
break;
case 282:
#line 1631 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '%', yyvsp[0].n);}
break;
case 283:
#line 1633 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '/', yyvsp[0].n);}
break;
case 284:
#line 1635 "a56.y"
{yyval.n = binary_op(yyvsp[-2].n, '*', yyvsp[0].n);}
break;
case 285:
#line 1637 "a56.y"
{yyval.n = unary_op('-', yyvsp[0].n);}
break;
case 286:
#line 1639 "a56.y"
{yyval.n = unary_op('~', yyvsp[0].n);}
break;
case 287:
#line 1641 "a56.y"
{yyval.n = yyvsp[-1].n;}
break;
case 288:
#line 1643 "a56.y"
{yyval.n = yyvsp[0].n;}
break;
#line 3289 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
