;	page	255
;	opt	mex,cex
;	lstcol	8,8,10,13,13
;	nolist

;
;
;	56k.inc
;
;	standard include file for DSP5600x.
;
;
;


;
;	interrupt/exception vectors
;

P_RESET		equ	p:$0000
STACK_ERROR	equ	p:$0002
TRACE		equ	p:$0004
P_SWI		equ	p:$0006
IRQA		equ	p:$0008
IRQB		equ	p:$000A
SSI_RX		equ	p:$000C
SSI_RX_ERROR	equ	p:$000E
SSI_TX		equ	p:$0010
SSI_TX_ERROR	equ	p:$0012
SCI_RX		equ	p:$0014
SCI_RX_ERROR	equ	p:$0016
SCI_TX		equ	p:$0018
SCI_IDLE_LINE	equ	p:$001A
SCI_TIMER	equ	p:$001C
NMI		equ	p:$001E
HOST_RX		equ	p:$0020
HOST_TX		equ	p:$0022
HOST_CMD	equ	p:$0024
P_ILLEGAL		equ	p:$003E




;
;	internal peripherals
;

PBC		equ	x:$FFE0
PCC		equ	x:$FFE1
PBDDR		equ	x:$FFE2
PCDDR		equ	x:$FFE3
PBD		equ	x:$FFE4
PCD		equ	x:$FFE5

HCR		equ	x:$FFE8
HRIE		equ	0
HTIE		equ	1
HCIE		equ	2
HF2		equ	3
HF3		equ	4

HSR		equ	x:$FFE9
HRDF		equ	0
HTDE		equ	1
HCP		equ	2
HF0		equ	3
HF1		equ	4
DMA		equ	7

HRX		equ	x:$FFEB
HTX		equ	x:$FFEB

CRA		equ	x:$FFEC
PM0		equ	0
PM1		equ	1
PM2		equ	2
PM3		equ	3
PM4		equ	4
PM5		equ	5
PM6		equ	6
PM7		equ	7
DC0		equ	8
DC1		equ	9
DC2		equ	10
DC3		equ	11
DC4		equ	12
WL0		equ	13
WL1		equ	14
PSR		equ	15

CRB		equ	x:$FFED
SHFD		equ	6
FSL0		equ	7
FSL1		equ	8
SYN		equ	9
GCK		equ	10
MOD		equ	11
TE		equ	12
RE		equ	13
TIE		equ	14
RIE		equ	15

SSISR		equ	x:$FFEE
IF0		equ	0
IF1		equ	1
TFS		equ	2
RFS		equ	3
TUE		equ	4
ROE		equ	5
TDE		equ	6
RDF		equ	7

TSR		equ	x:$FFEE

RX		equ	x:$FFEF
TX		equ	x:$FFEF

SCR		equ	x:$FFF0
WDS0		equ	0
WDS1		equ	1
WDS2		equ	2
SSFTD		equ	3
SBK		equ	4
WAKE		equ	5
RWU		equ	6
WOMS		equ	7
SCIRE		equ	8
SCITE		equ	9
ILIE		equ	10
SCIRIE		equ	11
SCITIE		equ	12
TMIE		equ	13
SCKP		equ	15

SSR		equ	x:$FFF1
TRNE		equ	0
TDRE		equ	1
RDRF		equ	2
IDLE		equ	3
SCIOR		equ	4
PE		equ	5
FE		equ	6
R8		equ	7

SCCR		equ	x:$FFF2
COD		equ	12
SCP		equ	13
RCM		equ	14
TCM		equ	15

STXA		equ	x:$FFF3

SRX_LO		equ	x:$FFF4
SRX_MID		equ	x:$FFF5
SRX_HI		equ	x:$FFF6

STX_LO		equ	x:$FFF4
STX_MID		equ	x:$FFF5
STX_HI		equ	x:$FFF6

BCR		equ	x:$FFFE
ZERO_WAIT 	equ	$0000
ONE_WAIT	equ	$1111
TWO_WAI		equ	$2222

IPR		equ	x:$FFFF
IRQA_IPL_0	equ	$0001
IRQA_IPL_1	equ	$0002
IRQA_IPL_2	equ	$0003
IRQA_EDGE	equ	$0004
IRQB_IPL_0	equ	$0008
IRQB_IPL_1	equ	$0010
IRQB_IPL_2	equ	$0018
IRQB_EDGE	equ	$0020
HOST_IPL_0	equ	$0400
HOST_IPL_1	equ	$0800
HOST_IPL_2	equ	$0C00
SSI_IPL_0	equ	$1000
SSI_IPL_1	equ	$2000
SSI_IPL_2	equ	$3000
SCI_IPL_0	equ	$4000
SCI_IPL_1	equ	$8000
SCI_IPL_2	equ	$C000


;
;	Scaling bits and Interrupt Masks for Mode Register (mr).
;	
;	Use with the andi or ori instructions as commented.
;

ENABLE_INTS	equ	$FC		; andi	#ENABLE_INTS,mr
DISABLE_IPL_0	equ	$01		; ori	#DISABLE_IPL_0,mr
DISABLE_IPL_1	equ	$02		; ori	#DISABLE_IPL_1,mr
DISABLE_IPL_2	equ	$03		; ori	#DISABLE_IPL_2,mr

SCALING_OFF	equ	$F3		; andi	#SCALING_OFF,mr
SCALE_DOWN	equ	$04		; ori	#SCALE_DOWN,mr
SCALE_UP		equ	$08		; ori	#SCALE_UP,mr




;
;	Various bits for Operating Mode Register (omr)
;

MODE_0		equ	$00
MODE_1		equ	$01
MODE_2		equ	$02
MODE_3		equ	$03
DE		equ	$04
SD		equ	$40
EA		equ	$80

	
	
	list
