/*********************************************************************
*                     crescent engineering                           *
*                     P.O. Box 1863                                  *	
*                     Montclair, NJ 07042                            *
*                     (C) Copyright 1994                             *
*********************************************************************/

/*
 *	Host code for simple delay line example.  (Borland C)
 */


#include "multisound.h"

#ifdef __linux__
#include "linkbd.h"
#endif

#define SAMPLE_RATE 44100.0
#define CHUNK_SIZE 4.0

void main(int argc,char** argv)
{
	  
	char input_buffer[1020], param;
	char bootc[255];
	char debc[255];
	char progc[255];
	int i;
	double x, delay_amt=0.0;

	#ifdef __linux__
	init_term();
	#endif
					

	debc[0]=progc[0]=bootc[0]='\0';

	if (argc < 2) { 
	  printf("Usage: mdb [-b boot_prog] [-d debug prog] program\n");
	  exit(-1);
	}
	
	for (i=1;i<argc;i++) {
	  if (*argv[i] == '-') {
	    argv[i]++;
	    if (*argv[i] == 'b')
	      strncpy(bootc,argv[++i],255);
	    else if (*argv[i] == 'd')
	      strncpy(debc,argv[++i],255);
	  }
	  else {
	    fprintf(stderr,"debugging %s ...\n",argv[i]);
	    strncpy(progc,argv[i],255);
	  }
	}
	if (bootc[0] == '\0') {
	  strcpy(bootc,"multisound.lod");
	  fprintf(stderr,"booting multisound.lod ..\n");
	}
	if (debc[0] =='\0') {
	  strcpy(debc,"debug.lod");
	  fprintf(stderr,"loading debug.lod ..\n");	  
	}
	if (progc[0] == '\0') { 
	  printf("Usage: mdb [-b boot_prog] [-d debug prog] program\n");
	  exit(-1);
	}

	if (ioperm(DSP_BASE,0xf,1)) {
	  fprintf(stderr,"Must be root to access the DSP IO ports\n");
	  exit(-1);
	}

	boot_dsp(bootc);		   /* load boot code */

	fprintf(stderr,"Loading debugger\n");
	load_dsp_application(debc);	 

	fprintf(stderr,"Loading %s\n",progc);
	load_dsp_application(progc);	  
	
	set_input_pot_level(0.0, 0.0);		  /* set pots to 0 dB full scale */
	set_aux_pot_level(0.0, 0.0);		 /*    relative to 1 V rms */

	do
		{
		
		if (delay_amt < 0.0)
			delay_amt = 0.0;			/* delay amount should never be less than zero */
		
		write_long("delay_amt", (long)(SAMPLE_RATE*delay_amt));		/* write number of samples of delay to DSP at delay_amt label */
		
		(void) fprintf(stderr, "[d]elay_amt = %lf seconds.\n", delay_amt);
		(void) fprintf(stderr, "enter param id (d) and value or de[b]ugger, [q]uit:\n");
		
		while (!kbhit())
			dspbugger(' ');		/* in case DSP hits a breakpoint or stops for other reason */
		
		(void) gets(input_buffer);
		(void) fprintf(stderr, "\n");
		
		(void) sscanf(input_buffer, "%c=%lf", &param, &x);
		
		if (param == 'd')
			delay_amt = x;
		
		if (param == 'b')
			dspbugger('?');		/* if 'b' was entered for parameter ID, go to debugger. */
		
		} while (param != 'q');
	}




