/*
 *
 *
 *		multisou.h
 *
 *		#include file for all multisound applications
 *
 *
 */



#ifndef _MULTISOUND_

#define _MULTISOUND_

#include <stdio.h>
#include <stdlib.h>


#define LONG int

#include <linux/autoconf.h>


/* DSP56 Host Port Addresses */


#define HP_DSPR		0x0A
#define HP_DSPRESET_ON	1
#define HP_DSPRESET_OFF	0

#define DSP_BASE	0x290

#define icrRegister	DSP_BASE+0
#define cvrRegister	DSP_BASE+1
#define isrRegister	DSP_BASE+2
#define txhRegister	DSP_BASE+5
#define txmRegister	DSP_BASE+6
#define txlRegister	DSP_BASE+7
#define rxhRegister	DSP_BASE+5
#define rxmRegister	DSP_BASE+6
#define rxlRegister	DSP_BASE+7




#define OTHER 0
#define SYMBOL 'S'
#define NOP 0x000000
#define RTI 0x000004
#define process_stereo_chunk 0x003F

#define RREQ 0x01
#define TREQ 0x02
#define HF0 0x08
#define HF1 0x10
#define HM0 0x20
#define HM1 0x40
#define INIT 0x80

#define HC 0x80

/* interrupt status register flags */

#define RXDF 0x01
#define TXDE 0x02
#define TRDY 0x04
#define HF2 0x08
#define HF3 0x10
#define DMA 0x40
#define HREQ 0x80


/*
	mem_space equates
*/
#define X 0x000000L
#define Y 0x010000L
#define P 0x020000L

#define READ_DSP 	0x000000L
#define WRITE_DSP 0x800000L


#define RESET_CMD 0x00
#define TRACE_CMD 0x02
#define SWI_CMD 0x06
#define NMI_CMD 0x0F
#define SET_PTR_HOST_CMD 0x12
#define SET_INPUT_GAIN_HOST_CMD 0x13
#define SET_AUX_GAIN_HOST_CMD 0x14

#define DSP_HC_TIMEOUT 1
#define DSP_WRITE_TIMEOUT 2
#define DSP_READ_TIMEOUT 3

#define TIMEOUT 300000     /* This should be adapted to the computer power */
#define INPUT_BUFFER_SIZE 1020


#define set_dsp_read_ptr(mem_space, ptr) set_dsp_read_write_ptr((READ_DSP+mem_space) + ptr)

#define set_dsp_write_ptr(mem_space, ptr) set_dsp_read_write_ptr((WRITE_DSP+mem_space) + ptr)

#define get_at_label(symbol_name, offset) (void)set_dsp_read_write_ptr((READ_DSP+(offset)) + hash_symbol(symbol_name))

#define put_at_label(symbol_name, offset) (void)set_dsp_read_write_ptr((WRITE_DSP+(offset)) + hash_symbol(symbol_name))

#define put_long(value) (void)write_dsp_data(value)



int set_dsp_read_write_ptr(register int mode_plus_ptr);

int host_command(register unsigned int cmd);

int write_dsp_data(register int data);

int read_dsp_data(int *data_ptr);

int hash_symbol(char *symbol_name);

int get_long(void);

int read_long(char *symbol_name);

void write_long(char *symbol_name, int value);

double get_double(void);

void put_double(double value);

double read_double(char *symbol_name);

void write_double(char *symbol_name, double value);

void set_input_pot_level(double dBr_left, double dBr_right);

void set_aux_pot_level(double dBr_left, double dBr_right);

void boot_dsp(char *boot_file);

void load_dsp_application(char *app_file);

void dspbugger(char cmd);


#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <math.h>


#endif

