/*
* Generated with LDDK Version 0.7-beta 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <maab_P.h>
#include <linux/version.h>

char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1


#ifdef LDDK_USE_REGISTER
    int maab_major = maab_MAJOR; 
  
struct file_operations maab_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
maab_mmap, 
maab_open, 
maab_close, 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif

int init_module(void)
{
  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(maab_major,"maab",&maab_fops) ){
      printk("can't get Major %d\n",maab_major);
      return(-EIO);
    }
  

#endif
  {
    #line 114 "maab.ddl" 

#include <linux/bios32.h>  /* pcibios_ ... */
#include <linux/pci.h>     /* kernel PCI Defs */
  
  extern maab_dev maab;

  int retval = MAAB_CANNOT_FIND;

  printk("maab initialize: ");

  if(!pcibios_present()){
    printk("maab: No PCI Bios, init failed \n");
    return MAAB_NO_PCI;
  }

  /* search in each slot for maab */
  for(maab.pci_index = 0; maab.pci_index < 0x7f; maab.pci_index++){
    
    /* device_fn */
    if(pcibios_find_device(MAAB_VendorId,MAAB_DeviceId, maab.pci_index, 
			   &maab.pci_bus, &maab.pci_device_fn) !=0)
      break; /* try next slot */

    pcibios_read_config_byte(maab.pci_bus,maab.pci_device_fn, 
			     PCI_INTERRUPT_LINE,&maab.pci_irq_line);

    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_REVISION_ID ,
			     &maab.pci_rev);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_CLASS_PROG ,
			     &maab.pci_class_prog);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn, 
			     PCI_CLASS_DEVICE,
			     &maab.pci_class);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_CACHE_LINE_SIZE,
			     &maab.pci_cache_size);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_LATENCY_TIMER,
			     &maab.pci_latency);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_HEADER_TYPE,
			     &maab.pci_header_type);
    pcibios_read_config_byte(maab.pci_bus, maab.pci_device_fn,
			     PCI_BIST,
			     &maab.pci_bist);

    pcibios_read_config_dword(maab.pci_bus, maab.pci_device_fn,
			      PCI_STATUS,
			      &maab.pci_status);
    pcibios_read_config_dword(maab.pci_bus, maab.pci_device_fn,
			      PCI_BASE_ADDRESS_0,
			      &maab.pci_base_addr);

    if((maab.pci_base_addr & PCI_BASE_ADDRESS_SPACE_IO)!= 0){
      printk("maab found:but MAAB MEM is i/O ??? -> maab try next \n");
      break;
      /*      return MAAB_IO_MAPPED; */
    }

    /* process info dtat */
    switch((maab.pci_base_addr & PCI_BASE_ADDRESS_MEM_TYPE_MASK)){

    case PCI_BASE_ADDRESS_MEM_TYPE_32:
      maab.pci_addr_memtype = "PCI MEM_TYPE 32Bit";
      break;

    case PCI_BASE_ADDRESS_MEM_TYPE_1M:
      maab.pci_addr_memtype = "PCI MEM_TYPE 1M";
      break;

    case PCI_BASE_ADDRESS_MEM_TYPE_64:
      maab.pci_addr_memtype = "PCI MEM_TYPE 64Bit";
      break;
    }

    if((maab.pci_base_addr & PCI_BASE_ADDRESS_MEM_PREFETCH) == 0x0)
      maab.pci_addr_prefetch = "PCI MEM_PREFETCH DISABLED";
    else
      maab.pci_addr_prefetch = "PCI MEM_PREFETCH ENEABLED";

    /* mask address */
    maab.pci_base_addr &= PCI_BASE_ADDRESS_MEM_MASK; 

    maab.io_size = MAAB_IO_SIZE; /* see DSP 563011 manual */
    maab.io_base_addr = ioremap(maab.pci_base_addr,maab.io_size);

    /* sucess */
    printk("maab found MAAB at bus %d index %d with irq-line %d,",
	   maab.pci_bus, maab.pci_index, maab.pci_irq_line);
    printk("addr 0x%x\n",maab.pci_base_addr);

    /*return MAAB_OK;*/
    retval = MAAB_OK;

  }; /* for each maab.pci_index */
  
  
  if(retval != MAAB_OK){
    printk("maab: MAAB Card not found, init failed \n");
    return MAAB_CANNOT_FIND;
  }
			

  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif
  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("maab : device busy, remove delayed\n");
  }

  {
    #line 221 "maab.ddl"

  extern maab_dev maab;

  iounmap(maab.io_base_addr); /* free mapping */
  maab_says(printk("mass says Good bye! \n"));
			

  }
#ifdef LDDK_USE_REGISTER
      if( unregister_chrdev(maab_major,"maab") != 0 ){
      printk("can't unregister maab, device busy \n");
    } else {
      printk("maab successfully removed\n");
    }
  

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

