;************************************************************
; test pci interface 
;************************************************************

; ------------  INCLUDES -----------------
		  nolist			;exlude from listing
		  include  'ioequ.asm' ; 		  
		  list			;start listing again

; ------------  DEFINES -------------------

PBASE 	equ 	$100  	; start programm at $100

        org	P:PBASE

; ---------- Programm init
START
main

; set clock: clock = 17MHz * 4 = 68MHz
; Bit  PLL-Controll register
; 0-11  M_MF Multiplication Factor        = 0x000003 (faktor 4)
; 12-14 M_DF Division Factor Bit Mask     = 0x000000 (faktor 1)
; 15    XTLR XTAL Range select bit        = 0x000000 (more than 200KHz)
; 16    XTLD XTAL disable bit             = 0x000000 (external oscillator)
; 17    PSTP Stop Processing State Bit    = 0x000000 (Stop PLL on STOP, low power)
; 18    PEN  PLL Enable Bit               = 0x040000 (yes)
; 19    COD Clock Output Disable Bit      = 0x000000 (no, to meassure clock)
; 20-23 M_PD Predivider Bits              = 0x000000 (Faktor 1)    
; M_PCTL   PLL Control register        SUM= 0x040003

	movep   #$040003,x:M_PCTL       ; set 

; Bus Control Register:
; Bit                                       set to
; 0-4   BA0W Area 0 Wait control          = 0x000001 (SRAM   1 wait states)
; 5-9   BA0W Area 1 Wait control          = 0x000180 (EEPROM 12 wait states)
; 10-12 BA0W Area 2 Wait control          = 0x000400 (TTL  1 wait states)
; 13-15 BA0W Area 3 Wait control          = 0x000000 (DRAM 0 wait states)
; 16-20 BA0W default Area Wait control    = 0x010000 (default 0 wait states)
; 21    BBS Bus State Bit                 read only
; 22    BLH Bus Lock Hold                 = 0x000000 (no)
; 23    BRH Bus Request Hold              = 0x000000 (no)
; M_BCR   Bus Control Register        SUM = 0x010581

        movep   #$010581,x:M_BCR
 
  ; AAR0V   = $010931    ; value programmed into AAR0 (SRAM Enable)
  ;  (32k words ext. SRAM located at x,y:$010000-$017FFF)
  ; compare 9 most significant bits, look for a match with address
  ; X:0000 0001 0xxx xxx xxxx xxxx, no packing, no muxing, P enabled,
  ; X and Y disabled, AAR0 pin active low, asynchronous SRAM-type access


;        movep   #AAR0V,x:M_AAR0    ; maps SRAM from p:$0000-$7fff

  ;AAR1V   EQU   $010809    ; value programmed into AAR1 (FLASH Enable)
  ;   (64k bytes FLASH located at p:$010000-$01FFFF)
  ; compare 8 most significant bits, look for a match with address
  ; X:0000 0001 xxxx xxx xxxx xxxx, no packing, no muxing, X enabled,
  ; P and Y disabled, AAR1 pin active low, asynchronous SRAM-type access

;        movep   #AAR1V,x:M_AAR1    ; set up flash space to be mapped from

;64 --------------- programm exec ---------------

loop
		  brclr    #M_HF2,x:M_DSR,_clrbit   ; if HF2 in HCR is set
	
		  bclr     #M_HF3,x:M_DCTR           ; clear HF3 Bit
		  jmp      loop

_clrbit                                   ;else
		  bset     #M_HF3,x:M_DCTR           ; set HF3 Bit
		  jmp      loop

		  end main